// DEMO8_11.CPP - Smooth scrolling demo

// INCLUDES ///////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN  

// you must #define INITGUID if not done elsewhere
#define INITGUID

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <objbase.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>
#include <ctime>
#include <fstream.h>

#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>

#include <ddraw.h>     // directX includes
#include "T3DLIB1.H"
#include "T3DLIB3.H"

// DEFINES ////////////////////////////////////////////////

// defines for windows 
#define WINDOW_CLASS_NAME "WINCLASS1"

// default screen size
#define SCREEN_WIDTH    800  // size of screen
#define SCREEN_HEIGHT   600
#define SCREEN_BPP      8    // bits per pixel

#define BITMAP_ID            0x4D42 // universal id for a bitmap
#define MAX_COLORS_PALETTE   256

#define NUM_TEXTURES		 10
#define NUM_TEXTURE          26 // normally this would be a multiple of 16 or something!
#define HORZ_TILE_NUM		 16
#define VERT_TILE_NUM		 12
#define TILE_WIDTH			 50
#define TEXT_X				 50
#define TEXT_Y				 50
#define WORLD_HEIGHT		 23
#define WORLD_WIDTH			 63
#define CHAR_HEIGHT			 85
#define CHAR_WIDTH			 65
#define	NUM_GIBS			 9
#define GIB_HEIGHT			 4
#define GIB_WIDTH			 4
#define NUM_SLAUGHTERS		 20
#define NUM_WALK_TEXT		 6
#define NUM_INFERNICANS		 7
#define FIRE_WIDTH			 16
#define FIRE_HEIGHT			 14
#define BEAM_WIDTH			 60
#define NUM_MINI			 9
#define MINI_WIDTH			 32
#define MINI_HEIGHT			 43
#define NUM_PEAS			 6
#define NUM_BOSS			 24
#define NUM_ICUS			 10
#define ICUS_HEIGHT			 88
#define ICUS_WIDTH			 160

// PROTOTYPES /////////////////////////////////////////////

// game console
int Game_Init(void *parms=NULL, int num_parms = 0);
int Game_Shutdown(void *parms=NULL, int num_parms = 0);
int Game_Main(void *parms=NULL,  int num_parms = 0);
int Game_Title(void *parm=NULL, int num_parms = 0);
int Game_Story(void *parm=NULL, int num_parms = 0);

void Slaughter_Hit(int damage, int dir);
void reset();
void print_story(char* text, int lines, int color);

// GLOBALS ////////////////////////////////////////////////

// windows vars
HWND      main_window_handle = NULL; // globally track main window
int       window_closed      = 0;    // tracks if window is closed
HINSTANCE main_instance      = NULL; // globally track hinstance

char buffer[1000];                // used to print text
ifstream In;
ofstream Out;

int option;
int level;
int levelbg;
bool boss = true;
bool keyUp;
int world_height;
int world_width;
//0 = Title, 1 = In Game
int screenLoc = 0;
bool screenChange = true;
int lineNum;
int lineCol;
int changeCount;

// Sound ID's
int newSound;
int loadSound;
int selectSound;
int att1Sound;
int att2Sound;
int att3Sound;
int fireSound;
int ddieSound;
int deadSound;
int hitSound; //gasp
int hdieSound; //Ugh
int valAttSound; //Sword
int maceAttSound; //Swish
int infAttSound; //Swoosh2
int hhitSound;   //bulletbody
int healSound;

int titleMusic;
int levelMusic[4];
int storyMusic;

// demo globals
BOB          textures;     // texture memory
BOB			 titleBG;	   // Title Screen Background
BOB			 titleCursor;  // Title Screen Cursor

struct levels {
	int startx;
	int starty;
	int height;
	int width;
	int bgNum;
	int endx[10];
	int endy[10];
};

struct character {
	BOB	bob;
	int state; //0 = standing, 1 = walking, 2 = attacking
	int xvel;
	int yvel;
	int dir; //0 = left, 1 = right
	int count;
	int health;
	int mana;
	int inv;
};

struct infernicans {
	BOB bob;
	int states[100];
	int loc[100][2];
	int xvel[100];
	int yvel[100];
	int maxx[100];
	int minx[100];
	int dir[100];
	int count[100];
	int curr_frame[100];
};

struct miniInfernicans {
	BOB bob;
	int type[100];
	int states[100];
	int loc[100][2];
	int dir[100];
	int count[100];
	int curr_frame[100];
	int health[100];
	int xvel[100];
};

struct peasants {
	BOB bob;
	int states[100];
	int loc[100][2];
	int dir[100];
	int count[100];
	int curr_frame[100];
	int health[100];
	int xvel[100];
};

struct gib {
	BOB bob;
	int state[100][90];
	int xvel[100][90];
	int yvel[100][90];
	int count[100];
	int loc[100][90][2];
};

struct fire {
	BOB bob;
	int state[100];
	int xvel[100];
	int yvel[100];
	int count[100];
	int loc[100][2];
};

struct mbeam {
	int state;
	int xvel;
	int yvel;
	int count;
	int x;
	int y;
};

struct bosses {
	BOB bob;
	int type[100];
	int states[100];
	int loc[100][2];
	int dir[100];
	int count[100];
	int curr_frame[100];
	int health[100];
	int xvel[100];
};

struct infernicus {
	BOB bob;
	int states[100];
	int loc[100][2];
	int dir[100];
	int count[100];
	int curr_frame[100];
	int health[100];
	int xvel[100];
};

//level levels[4];
levels levelList[4];

infernicus Icus;
bosses Boss;
peasants Peas;
miniInfernicans Mini;
character Slaughter;
infernicans Infs;
gib Gibs;
fire Flames;
mbeam beam;

//DDSURFACEDESC2 ddsd;

int world_x = 0,   // current position of viewing window
    world_y = 0;

int origWorld[4][23][63];
int world[4][23][63]=
{
10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,
10,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 10,
10,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 10,
10,  2,  1,  1,  2,  2,  1,  1,  2,  2,  1,  1,  2,  2,  1,  1,  2,  2,  1,  1,  2,  2,  1,  1,  2,  2,  1,  1,  2,  1,  1,  1,  1,  1,  1,  1,  2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, -5,  1,  1,  1, -5,  1, -5,  1,  1,  1,  1,  1,  1,  1, 10,
10,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, -5,  1,  1,  1,  1, 10,
10,  1,  1,  1,  1,  1, -5,  1, -5, -5,  1,  1,  1, -5, -5,  1, -5,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, -5, -5,  1,  1,  1, 10, 10, 10, 10, 10, 10, 10,  10, 10, 10, 10, 10, 10, 10, 1,  1,  1, 10,
10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,  10, 10, 10, 10, 10, 10, 10, 10, 1,  1,  1, 10,
10, 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  10, 10, -5,  1,  1,  1,  1,  2,  2,  1,  1,  1,  2,  2,  1,  1,  1,  1,  1,  1,  1, 10, 10, 10, 10, 10, 10, 10,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 10,  1,  1, 10,
10, 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  10, 10, 10, 10, -5, -5,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 10, 10, 10, 10, 10, 10, 10, 10,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 10,
10, 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  10, 10, 10, 10, 10, 10,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 10,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, -5, -5,  1,  1,  1,  1, 10, 10,
10, 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  10, 10, 10, 10, 10, 10, 10, 10,  1, -5,  1,  1,  1,  1,  1,  1,  1,  1, 10,  1,  1,  1,  1,  1,  2,  2,  1,  1,  1,  2,  2,  1,  1,  1,  1,  1,  1,  1, 10, 10, 10, 10, 10, 10,  9, 10,
10, 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  10, 10, 10, 10, 10, 10, 10, 10, 10, 10, -5, -5,  1,  1,  1,  1,  1, 10,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 10,  9,  9,  9,  9,  9,  1,  9, 10,
10, 9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, -5,  1,  1, -5, 10,  1,  1,  2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 10,  9,  9,  9,  9,  9,  9,  9,  9, 10,
10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,  1,  1,  1,  1,  1,  1,  1, -5,  1,  1,  1,  1,  1, -5,  1, -5,  1, -5,  1, 10,  9,  9,  9,  9,  9,  9,  9,  9,  9, 10,
10,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  1,  1,  1,  1,  1,  1,  1, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, 10,
10,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, 10,
10,  2,  1,  1,  2,  2,  1,  1,  2,  2,  1,  1,  2,  2,  1,  1,  2,  2,  1,  1,  2,  2,  1,  1,  1,  1,  1,  1,  1,  1, -5,  1,  1, -5,  1,  1,  1,  1,  1,  1, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9, 10,
10,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,
10,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, -5,  1, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,
10,  2,  1,  1,  2,  2,  1,  1,  2,  2,  1,  1,  2,  2,  1,  1,  2,  2,  1,  1,  2,  2,  1, -5,  1,  1, 10, 10, 10, 9,  9,  10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,
 1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1, 10, 10, 10, 10, 9,  9,  9,  9,  10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,
 1,  1,  1, -5,  1,  1,  1, -5,  1,  1,  1,  1, -5,  1,  1,  1, -5,  1,  1, -5,  1,  1, 10, 10, 10, 10, 10, 10, 9,  9,  9,  9,  10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,
10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,

24,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  3,  5,  5,  5,  5,  3,  3,  3,  3,  3,  5,  5,
24,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  3,  5,  5,  5,  5,  3,  3,  3,  3,  3,  5,  5,
24,  5,  5,  5,  5,  5,  5,  3,  4,  4,  4,  3,  5,  5,  5,  5,  5,  5,  3,  4,  4,  4,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  3,  4,  4,  4,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  3,  4,  4,  4,  3,  5,  5,  5,  5,  3,  4,  4,  4,  3,  5,  5,
24,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,
24,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,
24,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,  5,  5,  5,  4,  4,  4,  5,  5,  5,
24,  5,  5,  5,  5,  5,  5, -1,  4,  4,  4,  5,  5, -2,  5,  5,  5,  5,  5,  4,  4,  4, -1,  5,  5, -1,  5, -2,  5,  5,  5,  5, -1,  5,  4,  4,  4,  5,  5,  5, -1, -2,  5,  5,  5, -1,  5,  5,  4,  4,  4,  5, -1,  5,  5,  5, -1,  4,  4,  4,  5,  5,  5,
24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,  4,  4,  5,  5,  5,
24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,  5,  5, 24,
24,  5,  5,  5,  5,  3,  3,  3,  3,  5,  5,  5,  5,  5,  3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, 24,
24,  5,  5,  5,  5,  3,  4,  4,  3,  5,  5,  5,  5,  5,  3,  4,  4,  3,  5,  5,  5,  5,  5,  5,  3,  4,  4,  3,  5,  5,  5,  5,  5,  5,  5,  3,  4,  4,  3,  5,  5,  5,  5,  5,  5,  3,  4,  4,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, 24, 24,
24,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, 24, 13, 24,
24,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5, 24, 13, 13, 24,
24,  5,  5,  5, -2,  5,  4,  4,  5, -1,  5,  5, -2,  5,  5,  4,  4,  5, -2,  5,  5,  5, -1,  5,  5,  4,  4, -1,  5,  5,  5,  5,  5,  5, -1,  5,  4,  4, -2,  5,  5,  5, -1,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5, -1,  5,  5,  5, 24, 13, 13, 13, 24,   
24,  5,  5, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13, 13, 13, 24,
24,  5,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  5,  5,  5,  5,  5,  3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  5,  5,  5,  5,  5,  5,  5,  3,  3,  3,  3,  5,  5,  5,  5, 24,           
13, 24,  5,  5,  5,  5,  5,  5,  3,  4,  4,  3,  5,  5,  5,  5,  5,  3,  4,  4,  3,  5,  5,  5,  5,  5,  5,  3,  4,  4,  3,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  3,  4,  4,  3,  5,  5,  5,  5,  5,  5,  5,  3,  4,  4,  3,  5,  5,  5,  5, 24,            
13, 13, 24,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5, 24,  
13, 13, 13, 24,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  5,  5,  5,  5,  5, 24,
13, 13, 13, 13, 24,  5,  5, -1,  5,  4,  4, -1,  5, -1,  5, -1,  5, -1,  4,  4,  5,  5, -1, -1,  5,  5,  5,  5,  4,  4,  5,  5, -1,  5,  5,  5, -1,  5,  5,  5,  5, -1,  5,  5,  4,  4,  5,  5, -1,  5,  5, -1,  5,  5,  5,  4,  4,  5,  5,  5, -7,  5, 24,
24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,

20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20,
20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20,
20, 0,  0,  0,  0,  0,  0,  0,  0,  0, -2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20,
20, 0,  0,  0,  0,  0,  0,  0, 20, 20, 20, 20, 0,  20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  -2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20, 20, 20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20,
20, 0,  0,  0,  0,  0, -1,  20, 20, 20, 20, 20, -2, 20, 0,  -1,  0,  0,  0, -1,  0,  0,  0, -2,  0,  0, -5,  0,  0,  20, 20, 0,  0,  20, -1,  0,  0,  0,  0,  0, -3,  0,  20, 20, 20, 20, 0,  0,  0,  0,  -5,  0,  0,  0,  0,  0,  -2,  0,  0,  0,  0,  0,  20,
20, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 0,  0,  20,
20, 20, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 0,  20,
20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20,
20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20,
20, 0,  0,  -5,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1,  0,  0,  0,  0,  20, 20, 0,  0, -5,  0,  0,  0,  0, -1,  20, 20, -2,  0,  0,  0,  0,  0,  0, -1,  0,  0,  20, 20, 20, 0,  0,  0,  0,  0, -3,  0,  0,  0,  0,  0,  0, -2,  0,  0,  0, -1,  0,  0,  20,
20, 0,  19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 20,
20, 0,  19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 20,
20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20,
20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  -2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  -2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20,
20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20, 20, 20, 20, 0,  0,  0,  0,  0,  0,  20, 20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20, 20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20, 20, 0,  0,  0,  0,  0,  0,  20,
20, 0,  -1,  0,  0,  0,  0,  0,  0, -1,  0,  0,  0,  0,  0,  0,  20, 20, 20, 20, 0,  0,  0,  0, -2,  0,  20, 20, 0,  0, -1,  0,  0,  0,  0,  0,  0, -1,  0,  0,  20, 20, 20, 20, 0,  0, -2,  0,  0,  0,  0, -3,  0,  0,  20, 20, 0, -2,  0,  0,  0,  0,  20,
20, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 0,  0,  0,  20,
20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  19, 0,  0,  20,
20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  -5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  19, 0,  20,
20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20, 20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20, 20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20, 
20, 0,  0,  0,  0,  0,  0,  -5,  0,  0,  0,  0,  0,  0,  20, 20, 20, 20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20, 20, 20, 20, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  20,
20,-6,  0,  0,  0,  0,  20, 20, 0,  0,  0,  -5,  0,  0,  20, 20, 20, 20, 0,  0,  0, -5,  0, -5,  0,  0, -5,  0,  0,  20, 20, 20, 0,  0, -5,  0,  0,  0, -5,  0,  0,  0,  20, 20, 20, 20, 0,  0,  0,  0, -5,  0,  0,  0,  0,  0,  0,  -5,  0,  0,  0,  0,  20,
20, 20, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 20,

18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18,
18,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 18,
18,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 18,
18,  0,  0,  0,  0, -1,  0, -5,  0,  0,  0, -5,  0,  0,  0, -3,  0,  0,  0,  0,  0,  0,  0,  0, -1,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0, -5,  0,  0, -4,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -5,  0, -2,  0,  0,  0,  0,  0, 18,	
18, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,  0, 18,
18,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 18,
18,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0, -1,  0,  0,  0,  0,  0, 18,
18, -4,  0,  0,  0,  0,  0,  0,  0,  -2,  0,  0,  0,  0, -2, 0, -1,  0,  0,  0, 0, 0, 0, 0, -5, -5,  0, -1,  0, -1,  0,  0,  0,  0,  0,  0,  0, 18, 18, 18, -2,  0,  0,  0,  0,  0,  0, 18, 18, -5,  0,  0,  0,  0, -1, 18, 18, 18, 18, 18,  0,  0, 18,
18, 11, 11,  0,  0, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 18,
18,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 18,
18,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 18,
18, -3,  0,  0,  0,  0, -1,  0,  0,  0, -5,  0, 18, 18, 18, 18, -1,  0,  0,  0,  0,  0,  0,  0,  -2, 18, 18, 18, 18,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -5, 18, 18, 18, 18,  0,  0,  0, -1, -4, 0,  0,  0,  0,  0, -4,  0,  0,  0, 18,
18, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,  0,  0, 18,
18, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,  0, 18,
18,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 18,
18,  0,  0,  0,  0,  0,  0,  0,  0, -1, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 18,
18,  0,  0,  0,  0,  0,  0,  0, 18, 18, 18, 18, 18,  0,  0,  0,  0,  0,  0,  0,  0, 18, 18,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 18, 18, 18,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 18,
18,  0,  0,  0,  0,  0,  0, 18, 18, 18, 18, 18, 18, -2,  0,  0,  0, -4,  0,  0,  0, 18, 18, -1, -1,  0, -5,  0,  0,  0,  0,  0, -1,  0,  0,  0,  0,  0,  0,  -2,  0,  0, 18, 18, 18, 18, 18,-3,  0,  0,  0,  0,  0,  0,  0, -5,  0,  0, -1,  0,  0,  0, 18,
18,  0,  0, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 18,
18,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 18,
18,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 18,
18,  0,  0,  0,  0,  0, -4,  0,  0,  0,  0, -5, -5, -5,  0,  0,  0, -1,  0,  0, -4,  0,  0,  0,  0,  0,  0,  0,  0, -1,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0, -4,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1,  0,  0,  0,  0,  0,  0,  0, -8, 18,
18, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11
};

// PROTOTYPES //////////////////////////////////////////////

LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
// this is the main message handler of the system
PAINTSTRUCT		ps;		// used in WM_PAINT
HDC				hdc;	// handle to a device context
char buffer[80];        // used to print strings

// what is the message 
switch(msg)
	{	
	case WM_CREATE: 
        {
		// do initialization stuff here
        // return success
		return(0);
		} break;
   
	case WM_PAINT: 
		{
		// simply validate the window 
   	    hdc = BeginPaint(hwnd,&ps);	 
        
        // end painting
        EndPaint(hwnd,&ps);

        // return success
		return(0);
   		} break;

	case WM_DESTROY: 
		{

		// kill the application, this sends a WM_QUIT message 
		PostQuitMessage(0);

        // return success
		return(0);
		} break;

	default:break;

    } // end switch

// process any messages that we didn't take care of 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{
int index;
WNDCLASSEX winclass; // this will hold the class we create
HWND	   hwnd;	 // generic window handle
MSG		   msg;		 // generic message
HDC        hdc;      // graphics device context

// first fill in the window class stucture
winclass.cbSize         = sizeof(WNDCLASSEX);
winclass.style			= CS_DBLCLKS | CS_OWNDC | 
                          CS_HREDRAW | CS_VREDRAW;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
winclass.lpszMenuName	= NULL;
winclass.lpszClassName	= WINDOW_CLASS_NAME;
winclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);

// save hinstance in global
main_instance = hinstance;

// register the window class
if (!RegisterClassEx(&winclass))
	return(0);

// create the window
if (!(hwnd = CreateWindowEx(NULL,                  // extended style
                            WINDOW_CLASS_NAME,     // class
						    "The Slaughter", // title
						    WS_POPUP | WS_VISIBLE,
					 	    0,0,	  // initial x,y
						    SCREEN_WIDTH,SCREEN_HEIGHT,  // initial width, height
						    NULL,	  // handle to parent 
						    NULL,	  // handle to menu
						    hinstance,// instance of this application
						    NULL)))	// extra creation parms
return(0);

// save main window handle
main_window_handle = hwnd;

// initialize game here
Game_Init();

while(TRUE)
	{
    // test if there is a message in queue, if so get it
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	   { 
	   // test if this is a quit
       if (msg.message == WM_QUIT)
           break;
	
	   // translate any accelerator keys
	   TranslateMessage(&msg);

	   // send the message to the window proc
	   DispatchMessage(&msg);
	   } // end if
    
       // main game processing goes here
		if(screenLoc == 0)
		{
			if(screenChange)
			{
				// Enter Title Screen Loop

				Load_Bitmap_File(&bitmap8bit, "title.bmp");

				Set_Palette(bitmap8bit.palette);

				Unload_Bitmap_File(&bitmap8bit);

				//if(!DMusic_Play(titleMusic)) return 0;
				//DMusic_Stop_All_MIDI()
				//DMusic_Play(titleMusic);

				screenChange = false;
			}
			if(DMusic_Status_MIDI(titleMusic) == MIDI_STOPPED)
				DMusic_Play(titleMusic);
			Game_Title();
		} else if (screenLoc == 1)
		{
			if(screenChange)
			{
				// enter main event loop

				Load_Bitmap_File(&bitmap8bit, "Ani.bmp");

				Set_Palette(bitmap8bit.palette);

				Unload_Bitmap_File(&bitmap8bit);

				//reset();
				screenChange = false;
			}
			if(DMusic_Status_MIDI(levelMusic[level]) == MIDI_STOPPED)
				DMusic_Play(levelMusic[level]);
			Game_Main();
		} else
		{
			if(screenChange)
			{
				reset();
				lineNum = 1;
				lineCol = 0;
				screenChange = false;
			}
			if(DMusic_Status_MIDI(titleMusic) == MIDI_STOPPED)
				DMusic_Play(titleMusic);
			Game_Story();
		}
       
	} // end while

// closedown game here
Game_Shutdown();

// return to Windows like this
return(msg.wParam);

} // end WinMain

// GAME PROGRAMMING CONSOLE FUNCTIONS ////////////////

int Game_Init(void *parms,  int num_parms)
{
// this function is where you do all the initialization 
// for your game

int index;         // looping var
int index2;		   // Another looping var
int index3;
//int infIndex = 0;  // Index to show how many Infernicans we have
char filename[80]; // used to build up files names

//Seed random number generator
srand(time(NULL));

//Set title cursor position
option = 0;

//Copy original worlds
for(index = 0; index < 4; index++)
{
	for(index2 = 0; index2 < 23; index2++)
	{
		for(index3 = 0; index3 < 63; index3++)
			origWorld[index][index2][index3] = world[index][index2][index3];
	}
}


DMusic_Init();

//titleMusic = DMusic_Load_MIDI("t7g034.mid");
titleMusic = DMusic_Load_MIDI("d_e1m5.mid");
levelMusic[0] = DMusic_Load_MIDI("gtl.mid");
levelMusic[1] = DMusic_Load_MIDI("megaop.mid");
levelMusic[2] = DMusic_Load_MIDI("duke.mid");
levelMusic[3] = DMusic_Load_MIDI("mk.mid");
storyMusic = DMusic_Load_MIDI("d_elm5.mid");


//if(titleMusic == -4)
//	return 0;

//Initialize Sound
if(!DSound_Init())
	return 0;

newSound = DSound_Load_WAV("new.wav");
DSound_Set_Freq(newSound, 22050);

loadSound = DSound_Load_WAV("load.wav");
DSound_Set_Freq(loadSound, 22050);

selectSound = DSound_Load_WAV("select.wav");
DSound_Set_Freq(selectSound, 22050);

ddieSound = DSound_Load_WAV("ddie.wav");
DSound_Set_Freq(ddieSound, 22050);

att1Sound = DSound_Load_WAV("att1.wav");
DSound_Set_Freq(att1Sound, 22050);

att2Sound = DSound_Load_WAV("att2.wav");
DSound_Set_Freq(att2Sound, 22050);

att3Sound = DSound_Load_WAV("att3.wav");
DSound_Set_Freq(att3Sound, 22050);

fireSound = DSound_Load_WAV("fire1.wav");
DSound_Set_Freq(fireSound, 22050);

deadSound = DSound_Load_WAV("terrified.wav");
DSound_Set_Freq(deadSound, 22050);

hitSound = DSound_Load_WAV("gasp.wav");
DSound_Set_Freq(hitSound, 22050);

hdieSound = DSound_Load_WAV("ugh.wav");
DSound_Set_Freq(hdieSound, 22050);

valAttSound = DSound_Load_WAV("sword.wav");
DSound_Set_Freq(valAttSound, 22050);

maceAttSound = DSound_Load_WAV("swish.wav");
DSound_Set_Freq(maceAttSound, 22050);

infAttSound = DSound_Load_WAV("swoosh2.wav");
DSound_Set_Freq(infAttSound, 22050);

hhitSound = DSound_Load_WAV("bulletbody.wav");
DSound_Set_Freq(hhitSound, 22050);

healSound = DSound_Load_WAV("tinkerbell.wav");
DSound_Set_Freq(healSound, 22050);

//Initialize Infernicans
for (index = 0; index < 100; index++)
	Infs.states[index] = -1;

Infs.bob.curr_frame = 0;

//Initialize levels
//level = 0;
//level = 1;

//level = 1;

levelList[0].bgNum = 1;
levelList[0].height = 23;
levelList[0].width = 63;
levelList[0].startx = 1;
levelList[0].starty = 2;
levelList[0].endx[0] = 0;
levelList[0].endy[0] = 20;
levelList[0].endx[1] = 0;
levelList[0].endy[1] = 21;
levelList[0].endx[2] = -1;
levelList[0].endy[2] = -1;

levelList[1].bgNum = 5;
levelList[1].height = 23;
levelList[1].width = 63;
levelList[1].startx = 1;
levelList[1].starty = 2;
levelList[1].endx[0] = 0;
levelList[1].endy[0] = 10;
levelList[1].endx[1] = 0;
levelList[1].endy[1] = 11;
levelList[1].endx[2] = -1;
levelList[1].endy[2] = -1;

levelList[2].bgNum = 0;
levelList[2].height = 23;
levelList[2].width = 63;
levelList[2].startx = 1;
levelList[2].starty = 2;
levelList[2].endx[0] = 0;
levelList[2].endy[0] = 10;
levelList[2].endx[1] = 0;
levelList[2].endy[1] = 11;
levelList[2].endx[2] = -1;
levelList[2].endy[2] = -1;

levelList[3].bgNum = 0;
levelList[3].height = 23;
levelList[3].width = 63;
levelList[3].startx = 1;
levelList[3].starty = 2;
levelList[3].endx[0] = 0;
levelList[3].endy[0] = 10;
levelList[3].endx[1] = 0;
levelList[3].endy[1] = 11;
levelList[3].endx[2] = -1;
levelList[3].endy[2] = -1;

// initialize directdraw
DDraw_Init(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP);

// load in texture maps
Load_Bitmap_File(&bitmap8bit, "texture.bmp");

// set the palette to background image palette
Set_Palette(bitmap8bit.palette);

// create the texture bob
if (!Create_BOB(&textures,0,0,TEXT_X,TEXT_Y,NUM_TEXTURE, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY))
   return(0);

// load each texture bitmap into the texture BOB object
for (index = 0; index < NUM_TEXTURE; index++)
    Load_Frame_BOB(&textures,&bitmap8bit,index,index%6,index/6,BITMAP_EXTRACT_MODE_CELL); 

// unload the texture map bitmap
Unload_Bitmap_File(&bitmap8bit);

//Load in Title Background
Load_Bitmap_File(&bitmap8bit, "title.bmp");

Set_Palette(bitmap8bit.palette);

if(!Create_BOB(&titleBG, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT, 1, BOB_ATTR_VISIBLE | 
		BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY))
	return(0);

Load_Frame_BOB(&titleBG, &bitmap8bit, 0, 0, 0, BITMAP_EXTRACT_MODE_ABS);

Unload_Bitmap_File(&bitmap8bit);

//Initialize Title Background
titleBG.x = 0;
titleBG.y = 0;
titleBG.curr_frame = 0;

//Load in Title Cursor
Load_Bitmap_File(&bitmap8bit, "cursor.bmp");

Set_Palette(bitmap8bit.palette);

if(!Create_BOB(&titleCursor, 0, 0, 28, 28, 1, BOB_ATTR_VISIBLE | 
		BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY))
	return(0);

Load_Frame_BOB(&titleCursor, &bitmap8bit, 0, 0, 0, BITMAP_EXTRACT_MODE_ABS);

Unload_Bitmap_File(&bitmap8bit);

//Initialize Title Cursor
titleCursor.x = 312;
titleCursor.y = 330;
titleCursor.curr_frame = 0;

//Load in Slaughter
Load_Bitmap_File(&bitmap8bit, "Ani.bmp");

Set_Palette(bitmap8bit.palette);

if(!Create_BOB(&Slaughter.bob, 0, 0, CHAR_WIDTH, CHAR_HEIGHT, NUM_SLAUGHTERS*2, BOB_ATTR_VISIBLE | 
		BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY, 167))
	return(0);

for (index = 0; index < NUM_SLAUGHTERS; index++)
	Load_Frame_BOB(&Slaughter.bob, &bitmap8bit, index, index%6, index/6, BITMAP_EXTRACT_MODE_CELL);

for (index = 0; index < NUM_SLAUGHTERS; index++)
	Load_Frame_BOB_R(&Slaughter.bob, &bitmap8bit, index+NUM_SLAUGHTERS, index%6, index/6, BITMAP_EXTRACT_MODE_CELL);

Unload_Bitmap_File(&bitmap8bit);

// Load in Infernican
Load_Bitmap_File(&bitmap8bit, "Infernican.bmp");

Set_Palette(bitmap8bit.palette);

if(!Create_BOB(&Infs.bob, 0, 0, CHAR_WIDTH, CHAR_HEIGHT, NUM_INFERNICANS*2, BOB_ATTR_VISIBLE | 
		BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY, 167))
	return(0);

for (index = 0; index < NUM_INFERNICANS; index++)
	Load_Frame_BOB(&Infs.bob, &bitmap8bit, index, index%6, index/6, BITMAP_EXTRACT_MODE_CELL);

for (index = 0; index < NUM_INFERNICANS; index++)
	Load_Frame_BOB_R(&Infs.bob, &bitmap8bit, index+NUM_INFERNICANS, index%6, index/6, BITMAP_EXTRACT_MODE_CELL);

Unload_Bitmap_File(&bitmap8bit);

// Load in Kimmy Gibbler
Load_Bitmap_File(&bitmap8bit, "gibs.bmp");

Set_Palette(bitmap8bit.palette);

if(!Create_BOB(&Gibs.bob, 0, 0, GIB_WIDTH, GIB_HEIGHT, NUM_GIBS, BOB_ATTR_VISIBLE | 
		BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY, 167))
	return(0);

for (index = 0; index < NUM_GIBS; index++)
	Load_Frame_BOB(&Gibs.bob, &bitmap8bit, index, index%6, index/6, BITMAP_EXTRACT_MODE_CELL);

Unload_Bitmap_File(&bitmap8bit);

// Load in Flames

Load_Bitmap_File(&bitmap8bit, "fire.bmp");

Set_Palette(bitmap8bit.palette);

if(!Create_BOB(&Flames.bob, 0, 0, FIRE_WIDTH, FIRE_HEIGHT, 2, BOB_ATTR_VISIBLE | 
		BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY, 167))
	return(0);

Load_Frame_BOB(&Flames.bob, &bitmap8bit, 1, 0, 0, BITMAP_EXTRACT_MODE_CELL);
Load_Frame_BOB_R(&Flames.bob, &bitmap8bit, 0, 0, 0, BITMAP_EXTRACT_MODE_CELL);

// Load in MiniInfernicans!

Load_Bitmap_File(&bitmap8bit, "miniInfernican.bmp");

Set_Palette(bitmap8bit.palette);

if(!Create_BOB(&Mini.bob, 0, 0, MINI_WIDTH, MINI_HEIGHT, NUM_MINI*2, BOB_ATTR_VISIBLE | 
		BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY, 167))
	return(0);

for (index = 0; index < NUM_MINI; index++)
	Load_Frame_BOB(&Mini.bob, &bitmap8bit, index, index%3, index/3, BITMAP_EXTRACT_MODE_CELL);

for (index = 0; index < NUM_MINI; index++)
	Load_Frame_BOB_R(&Mini.bob, &bitmap8bit, index+NUM_MINI, index%3, index/3, BITMAP_EXTRACT_MODE_CELL);

Unload_Bitmap_File(&bitmap8bit);

// Load in Peasants
Load_Bitmap_File(&bitmap8bit, "caveman.bmp");

Set_Palette(bitmap8bit.palette);

if(!Create_BOB(&Peas.bob, 0, 0, CHAR_WIDTH, CHAR_HEIGHT, NUM_PEAS*2, BOB_ATTR_VISIBLE | 
		BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY, 167))
	return(0);

for (index = 0; index < NUM_PEAS; index++)
	Load_Frame_BOB(&Peas.bob, &bitmap8bit, index, index%6, index/6, BITMAP_EXTRACT_MODE_CELL);

for (index = 0; index < NUM_PEAS; index++)
	Load_Frame_BOB_R(&Peas.bob, &bitmap8bit, index+NUM_PEAS, index%6, index/6, BITMAP_EXTRACT_MODE_CELL);

Unload_Bitmap_File(&bitmap8bit);

// Load in Bosses
Load_Bitmap_File(&bitmap8bit, "boss.bmp");

Set_Palette(bitmap8bit.palette);

if(!Create_BOB(&Boss.bob, 0, 0, CHAR_WIDTH, CHAR_HEIGHT, NUM_BOSS*2, BOB_ATTR_VISIBLE | 
		BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY, 167))
	return(0);

for (index = 0; index < NUM_BOSS; index++)
	Load_Frame_BOB(&Boss.bob, &bitmap8bit, index, index%6, index/6, BITMAP_EXTRACT_MODE_CELL);

for (index = 0; index < NUM_BOSS; index++)
	Load_Frame_BOB_R(&Boss.bob, &bitmap8bit, index+NUM_BOSS, index%6, index/6, BITMAP_EXTRACT_MODE_CELL);

Unload_Bitmap_File(&bitmap8bit);

// Load in Infernicus
Load_Bitmap_File(&bitmap8bit, "Infernicus.bmp");

Set_Palette(bitmap8bit.palette);

if(!Create_BOB(&Icus.bob, 0, 0, ICUS_WIDTH, ICUS_HEIGHT, NUM_ICUS*2, BOB_ATTR_VISIBLE | 
		BOB_ATTR_MULTI_FRAME, DDSCAPS_SYSTEMMEMORY, 167))
	return(0);

for (index = 0; index < NUM_ICUS; index++)
	Load_Frame_BOB(&Icus.bob, &bitmap8bit, index, index%2, index/2, BITMAP_EXTRACT_MODE_CELL);

for (index = 0; index < NUM_ICUS; index++)
	Load_Frame_BOB_R(&Icus.bob, &bitmap8bit, index+NUM_ICUS, index%2, index/2, BITMAP_EXTRACT_MODE_CELL);

Unload_Bitmap_File(&bitmap8bit);

// set clipping rectangle to screen extents so mouse cursor
// doens't mess up at edges
RECT screen_rect = {0,0,screen_width,screen_height}; // 32 pixels at the bottom for controls

// notice at bottom of screen a blank rect, this would be for your
// control panel for example
lpddclipper = DDraw_Attach_Clipper(lpddsback,1,&screen_rect);

// hide the mouse
ShowCursor(FALSE);

// return success
return(1);

} // end Game_Init

///////////////////////////////////////////////////////////

int Game_Shutdown(void *parms,  int num_parms)
{
// this function is where you shutdown your game and
// release all resources that you allocated

// kill texture memory
Destroy_BOB(&textures);
// kill Slaughter memory
Destroy_BOB(&Slaughter.bob);

// shutdonw directdraw
DDraw_Shutdown();

// Shutdown Sound
DMusic_Delete_All_MIDI();
DSound_Delete_All_Sounds();
DSound_Shutdown();

// return success
return(1);
} // end Game_Shutdown

///////////////////////////////////////////////////////////

int Game_Title(void *parms, int num_parms)
{
	// start the timing clock
	Start_Clock();

	if (KEY_DOWN(VK_ESCAPE))
	{
		screenChange = true;
		screenLoc = 1;
	}

	if (KEY_DOWN(VK_RETURN))
	{
		if(keyUp)
		{
			if(option == 0)
			{
				level = 0;
				DSound_Play(newSound);
				screenChange = true;
				screenLoc = 2;
				keyUp = false;
			} else
			{
				In.open("save");
				level = In.get() - '0';
				if(In.eof())
					level = 0;
				In.close();
				DSound_Play(loadSound);
				screenChange = true;
				screenLoc = 2;
				keyUp = false;
			}
		}
	} else
		keyUp = true;

	// clear the drawing surface
	DDraw_Fill_Surface(lpddsback, 0);
	Draw_BOB(&titleBG, lpddsback);

	if (KEY_DOWN(VK_UP))
    {
		DSound_Play(selectSound);
		titleCursor.y = 330;
		option = 0;
    } // end if
	else if (KEY_DOWN(VK_DOWN))
    {
		DSound_Play(selectSound);
		titleCursor.y = 402;
		option = 1;
    } // end if

	Draw_BOB(&titleCursor, lpddsback);
	// flip the surfaces
	DDraw_Flip();

	// sync to 30 fps
	Wait_Clock(30);

	// return success
	return(1);
}

///////////////////////////////////////////////////////////

int Game_Story(void *parms, int num_parms)
{
	// start the timing clock
	Start_Clock();

	if (KEY_DOWN(VK_ESCAPE))
	{
		screenChange = true;
		screenLoc = 1;
	}

	if (KEY_DOWN(VK_RETURN))
	{
		if(keyUp)
		{
			screenChange = true;
			if (level < 4)
				screenLoc = 1;
			else
				screenLoc = 0;
			keyUp = false;
		}
	} else
		keyUp = true;

	// clear the drawing surface
	DDraw_Fill_Surface(lpddsback, 0);

	if(level == 0)
	{
		lineCol += 3;
		if(lineCol > 255)
		{
			if(lineNum < 14)
			{
				lineNum++;
				lineCol = 0;
			}
			else
				lineCol = 255;
		}
		sprintf(buffer, "        Level 1\nIt was a dark time.\nAfter his great victory against the Infernican army,\nLord Slaughter finally realized the plight of Earth D2.\nIt was ruled by weaklings.\nLord Slaughter decided to take matters into his own hands,\nHe payed the Validictorian a little visit.\nUpon seeing Lord Slaughter the Valedictorian took flight.\nThe people of Earth D2 were dellusioned,\nThey took up arms against Lord Slaughter.\nThat was a mistake.\nIt was time for Slaughter.\nIt was time for death.\n        Press Enter to Begin");
		print_story(buffer, lineNum, lineCol);
	} else if (level == 1)
	{
		lineCol += 3;
		if(lineCol > 255)
		{
			if(lineNum < 10)
			{
				lineNum++;
				lineCol = 0;
			}
			else
				lineCol = 255;
		}
		sprintf(buffer, "        Level 2\nSlaughter successfully escaped the people of Earth D2.\nWhy could the people not see it?\nTo be ruled by weaklings was worse than being a weakling.\nSlaughter contemplated this as he entered into the dense Forest of Doom.\nSuddenly a demon jumped out from the underbrush.\nIt's an Infernican!\nLooks like this might get messy...\nMessy for them.\n        Press Enter to Begin");
		print_story(buffer, lineNum, lineCol);
	}else if (level == 2)
	{
		lineCol += 3;
		if(lineCol > 255)
		{
			if(lineNum < 11)
			{
				lineNum++;
				lineCol = 0;
			}
			else
				lineCol = 255;
		}
		sprintf(buffer, "        Level 3\nSlaughter emerged from the jungle victorious.\nDamn those Infernicans\nDamn the Validictorian.\nThe dark bond was now apparent.\nWith the defeat of General Motors the alliance between Validictor and the Infernicans was in the open.\nIt was time to hunt the Infernicans down.\nSlaughter made his way to the snowy plains of Frostmut,\nAnd from there he would move to the scorching desert.\nThe home of the Infernicans\n        Press Enter to Begin");
		print_story(buffer, lineNum, lineCol);
	}else if (level == 3)
	{
		lineCol += 3;
		if(lineCol > 255)
		{
			if(lineNum < 6)
			{
				lineNum++;
				lineCol = 0;
			}
			else
				lineCol = 255;
		}
		sprintf(buffer, "        Level 4\nWith the death of the Valedictorian nothing stood in Slaughters way\nFinally Slaughter arrived at the home of the Infernicans.\nIt was time to do battle with king of the Infernicans himeself,\nInfernicus.\n        Press Enter to Begin");
		print_story(buffer, lineNum, lineCol);
	} else if (level == 4)
	{
		lineCol += 3;
		if(lineCol > 255)
		{
			if(lineNum < 7)
			{
				lineNum++;
				lineCol = 0;
			}
			else
				lineCol = 255;
		}
		sprintf(buffer, "        Victory\nLord Slaughter\nhas conquered all foes.\nThe world is yours.\nUse it well.\n        You win!\n        Press Enter to Return to Title Screen");
		print_story(buffer, lineNum, lineCol);
	}

	// flip the surfaces
	DDraw_Flip();

	// sync to 30 fps
	Wait_Clock(30);

	// return success
	return(1);
} // End Game_Story

///////////////////////////////////////////////////////////

int Game_Main(void *parms, int num_parms)
{
// this is the workhorse of your game it will be called
// continuously in real-time this is like main() in C
// all the calls for your game go here!

int index, index_x, index_y;  // looping vars
int start_map_x,start_map_y,  // map positions
    end_map_x,end_map_y; 

int feety;
int chesty;
int heady;
int feetx1;
int feetx2;
int midx1;
int midx2;

int result;
int result2;
int index2, index3;

int offset_x, offset_y;       // pixel offsets within cell

// check of user is trying to exit
if (KEY_DOWN(VK_ESCAPE))
    PostMessage(main_window_handle, WM_DESTROY,0,0);

// start the timing clock
Start_Clock();

// clear the drawing surface
DDraw_Fill_Surface(lpddsback, 0);
int max_h;
int xmove = 0;  //Test if no direction is being held, or if both are being held
// check for movement (scrolling)
if(Slaughter.state >= 0)
{
if (KEY_DOWN(VK_RIGHT) && Slaughter.state < 2)
    {
	/*
	max_h = (world_width - HORZ_TILE_NUM) * TEXT_X;
    if ((world_x+=4) >= max_h)
       world_x = max_h - 1;
	*/
	if(Slaughter.xvel < 4)
		Slaughter.xvel += 1;
	xmove++;
	if(Slaughter.state == 0)
		Slaughter.dir = 0;

    } // end if
if (KEY_DOWN(VK_LEFT) && Slaughter.state < 2)
    {
	/*
    if ((world_x-=4) < 0)
       world_x = 0;
	*/
	if(Slaughter.xvel > -4)
		Slaughter.xvel -= 1;

	if(Slaughter.state == 0)
		Slaughter.dir = 1;

	xmove--;
	} // end if

if (KEY_DOWN(VK_UP))
    {
	/*
    if ((world_y-=4) < 0)
       world_y = 0;
	*/
	if(Slaughter.state == 0)
	{
		Slaughter.state = 1;
		Slaughter.yvel = -16;
	}

    } // end if

if (KEY_DOWN(VK_CONTROL))
{
	if(Slaughter.state == 0 && Slaughter.mana >= 400 && beam.count <= 0)
	{
		DSound_Play(att3Sound);
		Slaughter.state = 3;
		Slaughter.xvel = 0;
		Slaughter.count = 3;
		Slaughter.bob.curr_frame = 0;
		Slaughter.mana -= 400;

		//Initialize Beam
		beam.count = 100;
		//beam.state = Slaughter.dir;
		if(Slaughter.dir == 1)
		{
			beam.state = 0;
			beam.x = Slaughter.bob.x + world_x - BEAM_WIDTH;
			beam.xvel = -6;
		} else
		{
			beam.state = 1;
			beam.x = Slaughter.bob.x + world_x + CHAR_WIDTH;
			beam.xvel = 6;
		}
		beam.yvel = 0;
		beam.y = Slaughter.bob.y + world_y + 40;
	}

} // end if

if (KEY_DOWN(VK_SHIFT))
{
	if(Slaughter.state == 0 && Slaughter.mana >= 700)
	{
		//needsound
		Slaughter.state = 3;
		Slaughter.xvel = 0;
		Slaughter.count = 3;
		Slaughter.bob.curr_frame = 0;
		Slaughter.mana -= 700;

		//Heal Slaughter
		DSound_Play(healSound);
		Slaughter.health +=35;
		if(Slaughter.health >= 100)
			Slaughter.health = 100;
	}
}

if (KEY_DOWN(VK_SPACE))
{
	if(Slaughter.state == 0)
	{
		DSound_Play(att1Sound);
		Slaughter.state = 2;
		Slaughter.xvel = 0;
		Slaughter.count = -2;
		Slaughter.bob.curr_frame = 10;
	}
}
}
if(xmove == 0 || Slaughter.xvel > 4 || Slaughter.xvel < -4)
{
	if(Slaughter.xvel > 0)
		Slaughter.xvel--;
	else if (Slaughter.xvel < 0)
		Slaughter.xvel++;
}

// compute starting map indices by dividing position by size of cell
start_map_x = world_x/TEXT_X; // use >> 6 for speed, but this is clearer
start_map_y = world_y/TEXT_Y; 

// compute end of map rectangle for best cast i.e. aligned on 64x64 boundary
end_map_x = start_map_x + HORZ_TILE_NUM - 1;
end_map_y = start_map_y + VERT_TILE_NUM - 1;

// now compute number of pixels in x,y we are within the tile, i.e
// how much is scrolled off the edge?
offset_x = -(world_x % TEXT_X);
offset_y = -(world_y % TEXT_Y);

// adjust end_map_x,y for offsets
if (offset_x)
   end_map_x++;

if (offset_y)
   end_map_y++;


// set starting position of first upper lh texture
int texture_x = offset_x;
int texture_y = offset_y;

//Check for falling
if(Slaughter.state >= 0)
{

feety = -offset_y + Slaughter.bob.y + CHAR_HEIGHT;
chesty = -offset_y + Slaughter.bob.y + (CHAR_HEIGHT+25)/2;
heady = -offset_y + Slaughter.bob.y+25;// + CHAR_HEIGHT/8;
feetx1 = -offset_x + Slaughter.bob.x + (CHAR_WIDTH) / 6;
feetx2 = -offset_x + Slaughter.bob.x + 5 * (CHAR_WIDTH) / 6;
midx1 = -offset_x + Slaughter.bob.x + CHAR_WIDTH/4;
midx2 = -offset_x + Slaughter.bob.x + 3*CHAR_WIDTH/4;
//int feetx3 = -offset_x + Slaughter.bob.x + 15;

if(world[level][start_map_y + ((feety + Slaughter.yvel + 1) / TEXT_Y)][start_map_x + ((feetx1) / TEXT_X)] < NUM_WALK_TEXT
	&& world[level][start_map_y + ((feety  + Slaughter.yvel + 1) / TEXT_Y)][start_map_x + ((feetx2) / TEXT_X)] < NUM_WALK_TEXT) {
	if(Slaughter.yvel < 10)
		Slaughter.yvel++;
	Slaughter.state = 1;
} else 
{
	//if (world[level][start_map_y + ((feety + Slaughter.yvel + 1) / TEXT_Y)][start_map_x + ((feetx1 + Slaughter.xvel) / TEXT_X)] != '0'
	//	&& world[level][start_map_y + ((feety  + Slaughter.yvel + 1) / TEXT_Y)][start_map_x + ((feetx2 + Slaughter.xvel) / TEXT_X)] != '0')
	if(Slaughter.yvel >= 0 && Slaughter.state < 2)
		Slaughter.state = 0;
//	else
//		Slaughter.state = 1;

	Slaughter.yvel = 0;
}

if(Slaughter.xvel > 0)
{
	if(!((world[level][start_map_y + (feety / TEXT_Y)][start_map_x + ((feetx2 + Slaughter.xvel + 1) / TEXT_X)] < NUM_WALK_TEXT)
		&& (world[level][start_map_y + (chesty / TEXT_Y)][start_map_x + ((feetx2 + Slaughter.xvel + 1) / TEXT_X)] < NUM_WALK_TEXT)
		&& (world[level][start_map_y + (heady / TEXT_Y)][start_map_x + ((feetx2 + Slaughter.xvel + 1) / TEXT_X)] < NUM_WALK_TEXT)))
		Slaughter.xvel = 0;
}

if(Slaughter.xvel < 0)
{
	if(!((world[level][start_map_y + ((feety + Slaughter.yvel) / TEXT_Y)][start_map_x + ((feetx1 + Slaughter.xvel - 1) / TEXT_X)] < NUM_WALK_TEXT)
		&& (world[level][start_map_y + ((chesty + Slaughter.yvel) / TEXT_Y)][start_map_x + ((feetx1 + Slaughter.xvel - 1) / TEXT_X)] < NUM_WALK_TEXT)
		&& (world[level][start_map_y + ((heady + Slaughter.yvel) / TEXT_Y)][start_map_x + ((feetx1 + Slaughter.xvel - 1) / TEXT_X)] < NUM_WALK_TEXT)))
		Slaughter.xvel = 0;
}

if(Slaughter.yvel < 0)
{
	if(!((world[level][start_map_y + ((heady + Slaughter.yvel - 1) / TEXT_Y)][start_map_x + ((midx1 + Slaughter.xvel) / TEXT_X)] < NUM_WALK_TEXT)
		&& (world[level][start_map_y + ((heady + Slaughter.yvel - 1) / TEXT_Y)][start_map_x + ((midx2 + Slaughter.xvel) / TEXT_X)] < NUM_WALK_TEXT)))
	{
		if(Slaughter.yvel < 0)
		{
			Slaughter.yvel = 0;
			Slaughter.bob.y = (int(Slaughter.bob.y+25 - offset_y) / 50) * 50 + offset_y-20;
		}
	}
}

Slaughter.bob.y += Slaughter.yvel;
Slaughter.bob.x += Slaughter.xvel;

//Slaughter AI
if(Slaughter.mana < 1000)
	Slaughter.mana++;

if(Slaughter.yvel > 2)
	Slaughter.bob.curr_frame = 4;
else if (Slaughter.yvel < 0)
	Slaughter.bob.curr_frame = 6;
else if (Slaughter.state == 2)
{
	Slaughter.count++;
	if(Slaughter.count > 0)
	{
		if(Slaughter.bob.curr_frame <= 14)
		{
			Slaughter.bob.curr_frame++;
			if(Slaughter.bob.curr_frame == 12)
				Slaughter.count = -10;
			else if (Slaughter.bob.curr_frame == 13)
			{
				//Check for hit
				
				if(Slaughter.dir == 1)
					result = Slaughter.bob.x - 10 + world_x;
				else
					result = Slaughter.bob.x + CHAR_WIDTH + 10 + world_x;
				
				result2 = Slaughter.bob.y + CHAR_HEIGHT/2 + 10 + world_y;

				for(index = 0; index < 100; index++)
				{
					// If attack1 hits Infernican
					if(Infs.states[index] >= 0 && Infs.loc[index][0] < result+4 && Infs.loc[index][0] + CHAR_WIDTH > result-4 
						&& Infs.loc[index][1] < result2 && Infs.loc[index][1] + CHAR_HEIGHT > result2-30)
					{
						DSound_Play(ddieSound);
					
						for(index2 = 0; index2 < 100; index2++)
						{
							if(Gibs.state[index2][0] == -1)
							{
								for(index3 = 0; index3 < 90; index3++)
								{
									//Big demon explode
									Gibs.state[index2][index3] = rand() % 3 + 3;
									Gibs.count[index2] = 40;
									if(Slaughter.dir == 0)
										Gibs.xvel[index2][index3] = rand() % 8 - 2;
									else
										Gibs.xvel[index2][index3] = rand() % 8 - 5;
									Gibs.yvel[index2][index3] = rand() % 5 - 3;
									Gibs.loc[index2][index3][0] = Infs.loc[index][0] + rand() % CHAR_WIDTH;
									Gibs.loc[index2][index3][1] = Infs.loc[index][1] + rand() % CHAR_HEIGHT;
								}
								index2 = 100;
							}
						}
						Infs.states[index] = -1;
					}

					// If attack1 hits miniInfernican
					if(Mini.states[index] >= 0 && Mini.loc[index][0] < result+4 && Mini.loc[index][0] + MINI_WIDTH > result-4 
						&& Mini.loc[index][1] < result2 && Mini.loc[index][1] + MINI_HEIGHT > result2-30)
					{
						Mini.health[index] -= 40;
						if(Mini.health[index] <= 0)
						{
							DSound_Play(ddieSound);
						
							for(index2 = 0; index2 < 100; index2++)
							{
								if(Gibs.state[index2][0] == -1)
								{
									for(index3 = 0; index3 < 90; index3++)
									{
										//Little demon explode
										Gibs.state[index2][index3] = rand() % 3 + 6;
										Gibs.count[index2] = 40;
										Gibs.xvel[index2][index3] = rand() % 1 - 0;
										Gibs.yvel[index2][index3] = rand() % 2 - 1;
										Gibs.loc[index2][index3][0] = Mini.loc[index][0] + rand() % MINI_WIDTH;
										Gibs.loc[index2][index3][1] = Mini.loc[index][1] + rand() % MINI_HEIGHT;
									}
									index2 = 100;
								}
							}
							Mini.states[index] = -1;
						} else
						{
							DSound_Play(hhitSound);
							if(Slaughter.dir == 0)
								Mini.xvel[index] = 14;
							else
								Mini.xvel[index] = -14;
						}
					}

					// If attack1 hits Peasant
					if(Peas.states[index] >= 0 && Peas.loc[index][0] < result+4 && Peas.loc[index][0] + CHAR_WIDTH > result-4 
						&& Peas.loc[index][1] < result2 && Peas.loc[index][1] + CHAR_HEIGHT > result2-30)
					{
						Peas.health[index] -= 40;
						if(Peas.health[index] <= 0)
						{
							DSound_Play(hdieSound);
						
							for(index2 = 0; index2 < 100; index2++)
							{
								if(Gibs.state[index2][0] == -1)
								{
									for(index3 = 0; index3 < 90; index3++)
									{
										//Peasant explode
										Gibs.state[index2][index3] = rand() % 3;
										Gibs.count[index2] = 40;
										if(Slaughter.dir == 0)
											Gibs.xvel[index2][index3] = rand() % 8 - 2;
										else
											Gibs.xvel[index2][index3] = rand() % 8 - 5;
										Gibs.yvel[index2][index3] = rand() % 5 - 3;
										Gibs.loc[index2][index3][0] = Peas.loc[index][0] + rand() % CHAR_WIDTH;
										Gibs.loc[index2][index3][1] = Peas.loc[index][1] + rand() % CHAR_HEIGHT;
									}
									index2 = 100;
								}
							}
							Peas.states[index] = -1;
						}
						/*
						else
						{
							if(Slaughter.dir == 0)
								Peas.xvel[index] = 14;
							else
								Peas.xvel[index] = -14;
						}
						*/
					} // End Peasant Hit

					// If attack1 hits Boss
					if(Boss.states[index] >= 0 && Boss.loc[index][0] < result+4 && Boss.loc[index][0] + CHAR_WIDTH > result-4 
						&& Boss.loc[index][1] < result2 && Boss.loc[index][1] + CHAR_HEIGHT > result2-30)
					{
						Boss.health[index] -= 40;
						Boss.states[index] = 0;
						if(Boss.health[index] <= 0)
						{
							DSound_Play(hdieSound);
						
							for(index2 = 0; index2 < 100; index2++)
							{
								if(Gibs.state[index2][0] == -1)
								{
									for(index3 = 0; index3 < 90; index3++)
									{
										//Boss explode
										Gibs.state[index2][index3] = rand() % 3;
										Gibs.count[index2] = 60;
										if(Slaughter.dir == 0)
											Gibs.xvel[index2][index3] = rand() % 8 - 2;
										else
											Gibs.xvel[index2][index3] = rand() % 8 - 5;
										Gibs.yvel[index2][index3] = rand() % 20 - 18;
										Gibs.loc[index2][index3][0] = Boss.loc[index][0] + rand() % CHAR_WIDTH;
										Gibs.loc[index2][index3][1] = Boss.loc[index][1] + rand() % CHAR_HEIGHT;
									}
									index2 = 100;
								}
							}
							Boss.states[index] = -1;
						}
						else
						{
							DSound_Play(hhitSound);
							if(Slaughter.dir == 0)
								Boss.xvel[index] = 14;
							else
								Boss.xvel[index] = -14;
						}
						
					} // End Boss Hit

					// If attack1 hits Infernicus
					if(Icus.states[index] >= 0 && Icus.loc[index][0]+45 < result+6 && Icus.loc[index][0] + ICUS_WIDTH - 45 > result-6 
						&& Icus.loc[index][1] < result2 && Icus.loc[index][1] + ICUS_HEIGHT > result2-30)
					{
						Icus.health[index] -= 40;
						Icus.states[index] = 0;
						if(Icus.health[index] <= 0)
						{
							DSound_Play(ddieSound);
							Icus.states[index] = -2;
							Icus.count[index] = 12;
						
							for(index2 = 0; index2 < 100; index2++)
							{
								if(Gibs.state[index2][0] == -1)
								{
									for(index3 = 0; index3 < 90; index3++)
									{
										//Infernicus explode
										Gibs.state[index2][index3] = rand() % 3 + 3;
										Gibs.count[index2] = 60;
										if(Slaughter.dir == 0)
											Gibs.xvel[index2][index3] = rand() % 8 - 2;
										else
											Gibs.xvel[index2][index3] = rand() % 8 - 5;
										Gibs.yvel[index2][index3] = rand() % 20 - 18;
										Gibs.loc[index2][index3][0] = Icus.loc[index][0] + 45 + rand() % (ICUS_WIDTH - 102);
										Gibs.loc[index2][index3][1] = Icus.loc[index][1] + rand() % ICUS_HEIGHT;
									}
									index2 = 100;
								}
							}
							//Icus.states[index] = -1;
						}
						else
						{
							DSound_Play(hhitSound);
							if(Slaughter.dir == 0)
								Icus.xvel[index] = 13;
							else
								Icus.xvel[index] = -13;
						}
						
					} // End Infernicus Hit
				}

				Slaughter.count = 0;
			}
			else
				Slaughter.count = -2;
		} else
		{
			Slaughter.state = 0;
			Slaughter.bob.curr_frame = 0;
		}

	}
} else if (Slaughter.state == 3)
{
	if(Slaughter.count > 0)
		Slaughter.count--;
	else
		Slaughter.state = 0;
} else if(Slaughter.xvel != 0)
{
	Slaughter.count += 1;
	if(Slaughter.count > 2)
	{
		Slaughter.count = 0;
		Slaughter.bob.curr_frame = (Slaughter.bob.curr_frame + 1)%10;
	}
}
else 
{
	Slaughter.count = 3;
	Slaughter.bob.curr_frame = 0;
}

if(Slaughter.inv > 0)
	Slaughter.inv--;

//Hit detection from enemies
if(Slaughter.inv <= 0) // If Slaughter is not invincible
{
//Get actual coords of Slaughter
int greater = 5 * CHAR_WIDTH / 6;
int less = CHAR_WIDTH / 6;
int slx = Slaughter.bob.x + world_x;
int sly = Slaughter.bob.y + world_y;

//Infernicans Hit Detection
for(index = 0; index < 100; index++)
{
	if(Infs.states[index] >= 0)
	{
		if(Infs.loc[index][0] + greater > slx + less &&
			Infs.loc[index][0] + less < slx + greater &&
			Infs.loc[index][1] + CHAR_HEIGHT > sly + 20 &&
			Infs.loc[index][1] + 10 < sly + CHAR_HEIGHT)
		{
			if(slx > Infs.loc[index][0])
				Slaughter_Hit(25, 1);
			else
				Slaughter_Hit(25, 0);
		}
	}
	//miniInfernican Hit Detection
	if(Mini.states[index] >= 0)
	{
		if(Mini.loc[index][0] + MINI_WIDTH > slx + less &&
			Mini.loc[index][0] < slx + greater &&
			Mini.loc[index][1] + MINI_HEIGHT > sly + 20 &&
			Mini.loc[index][1] < sly + CHAR_HEIGHT)
		{
			if(slx > Mini.loc[index][0])
				Slaughter_Hit(20, 1);
			else
				Slaughter_Hit(20, 0);
		}
	}

	//Peasant Hit Detection
	if(Peas.states[index] >= 0)
	{
		if(Peas.loc[index][0] + greater > slx + less &&
			Peas.loc[index][0] + less < slx + greater &&
			Peas.loc[index][1] + CHAR_HEIGHT > sly + 20 &&
			Peas.loc[index][1] + 10 < sly + CHAR_HEIGHT)
		{
			if(slx > Peas.loc[index][0])
				Slaughter_Hit(20, 1);
			else
				Slaughter_Hit(20, 0);
		}
	}

	//Boss Hit Detection
	if(Boss.states[index] >= 0)
	{
		if(Boss.loc[index][0] + greater > slx + less &&
			Boss.loc[index][0] + less < slx + greater &&
			Boss.loc[index][1] + CHAR_HEIGHT > sly + 20 &&
			Boss.loc[index][1] + 10 < sly + CHAR_HEIGHT)
		{
			if(slx > Boss.loc[index][0])
				Slaughter_Hit(30, 1);
			else
				Slaughter_Hit(30, 0);
		}
	}

	//Infernicus Hit Detection
	if(Icus.states[index] >= 0)
	{
		if(Icus.loc[index][0] + ICUS_WIDTH - 45 > slx + less &&
			Icus.loc[index][0] + 45 < slx + greater &&
			Icus.loc[index][1] + CHAR_HEIGHT > sly + 20 &&
			Icus.loc[index][1] + 10 < sly + CHAR_HEIGHT)
		{
			if(slx > Icus.loc[index][0] + 45)
				Slaughter_Hit(30, 1);
			else
				Slaughter_Hit(30, 0);
		}
	}

	//Fire Hit Detection
	if(Flames.state[index] >= 0)
	{
		if(Flames.loc[index][0] + FIRE_WIDTH > slx + less &&
			Flames.loc[index][0] < slx + greater &&
			Flames.loc[index][1] + FIRE_HEIGHT > sly + 20 &&
			Flames.loc[index][1] < sly + CHAR_HEIGHT)
		{
			if(slx > Flames.loc[index][0] - FIRE_WIDTH/2)
				Slaughter_Hit(20, 1);
			else
				Slaughter_Hit(20, 0);
		}
	}
}
} //End if Slaughter is not invincible
} //End if Slaughter is alive
else
{
	Slaughter.count--;
	if(Slaughter.count > 0)
	{
		Slaughter_Hit(0, 0);
	} else if (Slaughter.count < -100)
	{
		screenChange = true;
		screenLoc = 0;
	}
}

//Infernican AI
for(index = 0; index < 100; index++)
{
	if(Infs.states[index] >= 0)
	{
		//If count is up, find something new to do
		//If state is 0, move left
		//If state is 1, move right
		//If state is 2, shoot fireball
		if(Infs.count[index] == 0)
		{
			//If they're onscreen, maybe shoot a fireball
			if(Infs.loc[index][0] + CHAR_WIDTH > world_x && Infs.loc[index][0] < world_x + SCREEN_WIDTH &&
				Infs.loc[index][1] + CHAR_HEIGHT > world_y && Infs.loc[index][1] < world_y + SCREEN_HEIGHT)
			{
				if(Infs.states[index] == 2)
				{
					result = rand() % 2;
					if(result == 1)
						result = 3;
				} else if (Infs.states[index] == 0)
				{
					result = rand() % 3 + 1;
				} else
				{
					result = rand() % 3;
				}

				if(result == 3)
				{
					Infs.count[index] = 100;
					Infs.xvel[index] = -2;
					Infs.dir[index] = 0;
					Infs.states[index] = 0;
				} else if (result == 0)
				{
					Infs.count[index] = 100;
					Infs.xvel[index] = 2;
					Infs.dir[index] = 1;
					Infs.states[index] = 1;
				} else //FIREBALL!
				{
					// Point self at Slaughter

					if(Slaughter.bob.x + world_x > Infs.loc[index][0])
						Infs.dir[index] = 1;
					else
						Infs.dir[index] = 0;
					//Find new fire ball
					
					DSound_Play(fireSound);
					for(index2 = 0; index2 < 100; index2++)
					{
						if(Flames.state[index2] == -1)
						{
							//Initialize fireball
							if(Infs.dir[index] == 0)
							{
								Flames.loc[index2][0] = Infs.loc[index][0] - FIRE_WIDTH;
								Flames.xvel[index2] = -3;
							}
							else
							{
								Flames.loc[index2][0] = Infs.loc[index][0] + CHAR_WIDTH/2;
								Flames.xvel[index2] = 3;
							}

							Flames.loc[index2][1] = Infs.loc[index][1] + 30;
							Flames.state[index2] = Infs.dir[index];
							Flames.yvel[index2] = 0;
							Flames.count[index2] = 100;

							index2 = 100;
						}
					}
					
					Infs.count[index] = 12;
					Infs.xvel[index] = 0;
					Infs.curr_frame[index] = 6;
					//Infs.dir[index = 
					Infs.states[index] = 2;
				}
				
			}
			//Else they are offscreen, so no fireballyflames
			else
			{
				//If we were shooting a fireball, pretend we were going left or right randomly
				if (Infs.states[index] == 2)
					Infs.states[index] = rand() % 2;

				//If we were going left, go right.  If we were going right, go left.
				if (Infs.states[index] == 1)
				{
					Infs.count[index] = 100;
					Infs.xvel[index] = -2;
					Infs.dir[index] = 0;
					Infs.states[index] = 0;
				} else
				{
					Infs.count[index] = 100;
					Infs.xvel[index] = 2;
					Infs.dir[index] = 1;
					Infs.states[index] = 1;
				}
			}

		} else
			Infs.count[index]--;
		
		feety = Infs.loc[index][1] + CHAR_HEIGHT;
		chesty = Infs.loc[index][1] + (CHAR_HEIGHT)/2;
		heady = Infs.loc[index][1];
		feetx1 = Infs.loc[index][0] + (CHAR_WIDTH) / 6;
		feetx2 = Infs.loc[index][0] + 5 * (CHAR_WIDTH) / 6;
		midx1 = Infs.loc[index][0] + CHAR_WIDTH/4;
		midx2 = Infs.loc[index][0] + 3*CHAR_WIDTH/4;

		//Move as needed
		if(Infs.xvel[index] > 0)
		{
			if(!((Infs.loc[index][0] + Infs.xvel[index] < Infs.maxx[index]
				&& Infs.loc[index][0] + Infs.xvel[index] > Infs.minx[index]
				&& world[level][feety / TEXT_Y][(feetx2 + Infs.xvel[index] + 1) / TEXT_X] < NUM_WALK_TEXT)
				&& (world[level][chesty / TEXT_Y][(feetx2 + Infs.xvel[index] + 1) / TEXT_X] < NUM_WALK_TEXT)
				&& (world[level][heady / TEXT_Y][(feetx2 + Infs.xvel[index] + 1) / TEXT_X] < NUM_WALK_TEXT)
				&& (world[level][(feety+TEXT_Y/2) / TEXT_Y][(feetx2 + Infs.xvel[index] + 1) / TEXT_X] >= NUM_WALK_TEXT)))
			{
				Infs.xvel[index] = 0;
				Infs.count[index] = 0;
				Infs.states[index] = 2;
			}
		}
		else if(Infs.xvel[index] < 0)
		{
			if(!(Infs.loc[index][0] + Infs.xvel[index] < Infs.maxx[index]
				&& Infs.loc[index][0] + Infs.xvel[index] > Infs.minx[index]
				&& (world[level][feety / TEXT_Y][(feetx1 + Infs.xvel[index] - 1) / TEXT_X] < NUM_WALK_TEXT)
				&& (world[level][chesty / TEXT_Y][(feetx1 + Infs.xvel[index] - 1) / TEXT_X] < NUM_WALK_TEXT)
				&& (world[level][heady / TEXT_Y][(feetx1 + Infs.xvel[index] - 1) / TEXT_X] < NUM_WALK_TEXT)
				&& (world[level][(feety+TEXT_Y/2) / TEXT_Y][(feetx1 + Infs.xvel[index] - 1) / TEXT_X] >= NUM_WALK_TEXT)))
			{
				Infs.xvel[index] = 0;
				Infs.count[index] = 0;
				Infs.states[index] = 2;
			}
		}

		if(Infs.xvel[index] != 0)
		{
			Infs.loc[index][1] += Infs.yvel[index];
			Infs.loc[index][0] += Infs.xvel[index];
			if(Infs.count[index] % 9 == 0)
				Infs.curr_frame[index] = (Infs.curr_frame[index] + 1) % 6;
		}
	}
}

//miniInfernican AI
for(index = 0; index < 100; index++)
{
	if(Mini.states[index] >= 0)
	{
		// Point self at Slaughter

		if(Slaughter.bob.x + world_x > Mini.loc[index][0])
			Mini.dir[index] = 1;
		else
			Mini.dir[index] = 0;

		//If count is up, find something new to do
		//If state is 0, wait
		//If state is 1, puff
		//If state is 2, shoot fireball
		Mini.count[index]--;
		//If they're onscreen, maybe shoot a fireball
		if(Mini.loc[index][0] + MINI_WIDTH > world_x && Mini.loc[index][0] < world_x + SCREEN_WIDTH &&
			Mini.loc[index][1] + MINI_HEIGHT > world_y && Mini.loc[index][1] < world_y + SCREEN_HEIGHT)
		{
			if(Mini.states[index] == 0)
			{
				if(Mini.count[index] <= 0)
				{
					Mini.states[index] = 1;
					Mini.count[index] = 20;
					Mini.curr_frame[index] = 1;
				}
			} else if (Mini.states[index] == 1)
			{
				if(Mini.count[index] <= 0)
				{
					Mini.states[index] = 2;
					Mini.count[index] = 10;
					Mini.curr_frame[index] = 2;

					//Find new fire ball
				
					DSound_Play(fireSound);
					for(index2 = 0; index2 < 100; index2++)
					{
						if(Flames.state[index2] == -1)
						{
							
							//Initialize fireball
							if(Mini.dir[index] == 0)
							{
								Flames.loc[index2][0] = Mini.loc[index][0] - FIRE_WIDTH;
								Flames.xvel[index2] = -3;
							}
							else
							{
								Flames.loc[index2][0] = Mini.loc[index][0] + MINI_WIDTH/2;
								Flames.xvel[index2] = 3;
							}

							Flames.loc[index2][1] = Mini.loc[index][1] + 12;
							Flames.state[index2] = Mini.dir[index];
							Flames.yvel[index2] = 0;
							Flames.count[index2] = 100;

							index2 = 100;
						}
					}
				}
			} else
			{
				if(Mini.count[index] <= 0)
				{
					Mini.count[index] = rand() % 100 + 40;
					Mini.states[index] = 0;
					Mini.curr_frame[index] = 0;
				}
			}
		}
		//Else they are offscreen, so no fireballyflames
		else
		{
			if(Mini.count[index] <= 0)
			{
				Mini.count[index] = rand() % 100 + 40;
				Mini.states[index] = 0;
				Mini.curr_frame[index] = 0;
			}
		}

		//Move as needed
		if(Mini.xvel[index] > 0)
		{
			feety = Mini.loc[index][1] + MINI_HEIGHT + 5;
			chesty = Mini.loc[index][1] + MINI_HEIGHT/2;
			midx1 = Mini.loc[index][0] + MINI_WIDTH + Mini.xvel[index];

			if(world[level][feety / TEXT_Y][midx1 / TEXT_X] < NUM_WALK_TEXT
				|| world[level][chesty / TEXT_Y][midx1 / TEXT_X] >= NUM_WALK_TEXT)
			{
				Mini.xvel[index] = 0;
			}
		}
		else if(Mini.xvel[index] < 0)
		{
			feety = Mini.loc[index][1] + MINI_HEIGHT + 5;
			chesty = Mini.loc[index][1] + MINI_HEIGHT/2;
			midx1 = Mini.loc[index][0] + Mini.xvel[index];

			if(world[level][feety / TEXT_Y][midx1 / TEXT_X] < NUM_WALK_TEXT
				|| world[level][chesty / TEXT_Y][midx1 / TEXT_X] >= NUM_WALK_TEXT)
			{
				Mini.xvel[index] = 0;
			}
		}
		Mini.loc[index][0] += Mini.xvel[index];
		if(Mini.xvel[index] > 0)
			Mini.xvel[index]--;
		else if(Mini.xvel[index] < 0)
			Mini.xvel[index]++;

	}
}

//Peasant AI
for(index = 0; index < 100; index++)
{
	if(Peas.states[index] >= 0)
	{
		// Point self at Slaughter

		if(Slaughter.bob.x + world_x > Peas.loc[index][0])
			Peas.dir[index] = 1;
		else
			Peas.dir[index] = 0;

		//If count is up, find something new to do
		//If state is 0, wait
		//If state is 1, puff
		//If state is 2, shoot fireball
		Peas.count[index]--;
		//If they're onscreen, move toward Slaughter
		if(Peas.loc[index][0] + CHAR_WIDTH > world_x && Peas.loc[index][0] < world_x + SCREEN_WIDTH &&
			Peas.loc[index][1] + CHAR_HEIGHT > world_y && Peas.loc[index][1] < world_y + SCREEN_HEIGHT)
		{
			if(Peas.states[index] == 0)
			{
				if(Peas.count[index] <= 0)
				{
					//If close enough to attack, then attack
					if(Peas.loc[index][0] + CHAR_WIDTH + 6 > Slaughter.bob.x + world_x
						&& Peas.loc[index][0] - CHAR_WIDTH - 6 < Slaughter.bob.x + world_x)
					{
						Peas.xvel[index] = 0;
						Peas.states[index] = 1;
						Peas.count[index] = 30;
						Peas.curr_frame[index] = 4;
					}
					else
					{
						Peas.states[index] = 0;
						Peas.count[index] = 4;
						Peas.curr_frame[index] = (Peas.curr_frame[index] + 1) % 3;
						if(Slaughter.bob.x + world_x > Peas.loc[index][0])
						{
							if(Peas.xvel[index] < 3)
								Peas.xvel[index]++;
						}
						else
						{
							if(Peas.xvel[index] > -3)
								Peas.xvel[index]--;
						}
					}
				}
			} else
			{
				if(Peas.count[index] <= 0)
				{
					Peas.curr_frame[index]++;
					if(Peas.curr_frame[index] >= 6)
					{
						Peas.curr_frame[index] = 0;
						Peas.count[index] = 20;
						Peas.states[index] = 0;
					} else if(Peas.curr_frame[index] == 5)
					{
						//Check for hit
						//Find new fire ball
						DSound_Play(maceAttSound);
						for(index2 = 0; index2 < 100; index2++)
						{
							if(Flames.state[index2] == -1)
							{
								
								//Initialize invisible fireball
								if(Peas.dir[index] == 0)
								{
									Flames.loc[index2][0] = Peas.loc[index][0] - FIRE_WIDTH;
									Flames.xvel[index2] = -3;
								}
								else
								{
									Flames.loc[index2][0] = Peas.loc[index][0] + CHAR_WIDTH;
									Flames.xvel[index2] = 3;
								}

								Flames.loc[index2][1] = Peas.loc[index][1] + CHAR_WIDTH/2 + 10;
								Flames.state[index2] = 10 + Peas.dir[index];
								Flames.yvel[index2] = 0;
								Flames.count[index2] = 2;

								index2 = 100;
							}
						}
						Peas.count[index] = 4;
					} else
						Peas.count[index] = 4;		
				}
			} 
		}

		//Move as needed
		if(Peas.states[index] == 3)
			Peas.xvel[index] = 0;
		else if(Peas.xvel[index] > 0)
		{
			feety = Peas.loc[index][1] + CHAR_HEIGHT + 5;
			chesty = Peas.loc[index][1] + CHAR_HEIGHT/2;
			midx1 = Peas.loc[index][0] + CHAR_WIDTH + Peas.xvel[index];

			if(world[level][feety / TEXT_Y][midx1 / TEXT_X] < NUM_WALK_TEXT
				|| world[level][chesty / TEXT_Y][midx1 / TEXT_X] >= NUM_WALK_TEXT)
			{
				Peas.xvel[index] = 0;
			}
		}
		else if(Peas.xvel[index] < 0)
		{
			feety = Peas.loc[index][1] + CHAR_HEIGHT + 5;
			chesty = Peas.loc[index][1] + CHAR_HEIGHT/2;
			midx1 = Peas.loc[index][0] + Peas.xvel[index];

			if(world[level][feety / TEXT_Y][midx1 / TEXT_X] < NUM_WALK_TEXT
				|| world[level][chesty / TEXT_Y][midx1 / TEXT_X] >= NUM_WALK_TEXT)
			{
				Peas.xvel[index] = 0;
			}
		}
		Peas.loc[index][0] += Peas.xvel[index];
		/*
		if(Peas.xvel[index] > 0)
			Peas.xvel[index]--;
		else if(Peas.xvel[index] < 0)
			Peas.xvel[index]++;
		*/

	}
} // End Peasant AI

boss = false;

//Boss AI
for(index = 0; index < 100; index++)
{
	if(Boss.states[index] >= 0)
	{
		boss = true;
		// Point self at Slaughter

		if(Slaughter.bob.x + world_x > Boss.loc[index][0])
			Boss.dir[index] = 1;
		else
			Boss.dir[index] = 0;

		//If count is up, find something new to do
		//If state is 0, wait
		//If state is 1, puff
		//If state is 2, shoot fireball
		Boss.count[index]--;
		//If they're onscreen, move toward Slaughter
		if(Boss.loc[index][0] + CHAR_WIDTH > world_x && Boss.loc[index][0] < world_x + SCREEN_WIDTH &&
			Boss.loc[index][1] + CHAR_HEIGHT > world_y && Boss.loc[index][1] < world_y + SCREEN_HEIGHT)
		{
			if(Boss.states[index] == 0)
			{
				if(Boss.count[index] <= 0)
				{
					//If close enough to attack, then attack
					if(Boss.loc[index][0] + CHAR_WIDTH + 9 > Slaughter.bob.x + world_x
						&& Boss.loc[index][0] - CHAR_WIDTH - 9 < Slaughter.bob.x + world_x)
					{
						Boss.xvel[index] = 0;
						Boss.states[index] = 1;
						if(Boss.type[index] == 1)
						{
							Boss.count[index] = 3;
							Boss.curr_frame[index] = 8;
						}
						else
						{
							Boss.count[index] = 9;
							Boss.curr_frame[index] = 8;
						}
					}
					else //Walk closer
					{
						Boss.states[index] = 0;
						Boss.count[index] = 4;
						Boss.curr_frame[index] = (Boss.curr_frame[index] + 1) % 8;
						if(Slaughter.bob.x + world_x > Boss.loc[index][0])
						{
							if(Boss.xvel[index] < 4)
								Boss.xvel[index]++;
							else if (Boss.type[index] == 1)
								Boss.xvel[index] = 5;
						}
						else
						{
							if(Boss.xvel[index] > -4)
								Boss.xvel[index]--;
							else if (Boss.type[index] == 1)
								Boss.xvel[index] = -5;
						}
					}
				}
			} else
			{
				//If it's time for a new frame
				if(Boss.count[index] <= 0)
				{
					Boss.curr_frame[index]++;
					if(Boss.curr_frame[index] >= 12)
					{
						Boss.curr_frame[index] = 0;
						Boss.count[index] = 20;
						Boss.states[index] = 0;
					} else if(Boss.curr_frame[index] == 10)
					{
						//Check for hit
						//Find new fire ball
						if(Boss.type[index] == 1)
							DSound_Play(valAttSound);
						else
							DSound_Play(maceAttSound);
						for(index2 = 0; index2 < 100; index2++)
						{
							if(Flames.state[index2] == -1)
							{
								
								//Initialize invisible fireball
								if(Boss.dir[index] == 0)
								{
									Flames.loc[index2][0] = Boss.loc[index][0] - FIRE_WIDTH;
									Flames.xvel[index2] = -3;
								}
								else
								{
									Flames.loc[index2][0] = Boss.loc[index][0] + CHAR_WIDTH;
									Flames.xvel[index2] = 3;
								}

								Flames.loc[index2][1] = Boss.loc[index][1] + CHAR_WIDTH/2 + 10;
								Flames.state[index2] = 10 + Boss.dir[index];
								Flames.yvel[index2] = 0;
								Flames.count[index2] = 4;

								index2 = 100;
							}
						}
						Boss.count[index] = 3;
					} else
						Boss.count[index] = 3;		
				}
			} 
		}

		//Move as needed
		if(Boss.states[index] == 3)
		{
			Boss.xvel[index] = 0;
			if(Boss.count[index] == 1)
				Boss.states[index] = 0;
		}
		else if(Boss.xvel[index] > 0)
		{
			feety = Boss.loc[index][1] + CHAR_HEIGHT + 5;
			chesty = Boss.loc[index][1] + CHAR_HEIGHT/2;
			midx1 = Boss.loc[index][0] + CHAR_WIDTH + Boss.xvel[index];

			if(world[level][feety / TEXT_Y][midx1 / TEXT_X] < NUM_WALK_TEXT
				|| world[level][chesty / TEXT_Y][midx1 / TEXT_X] >= NUM_WALK_TEXT)
			{
				Boss.xvel[index] = 0;
			}
		}
		else if(Boss.xvel[index] < 0)
		{
			feety = Boss.loc[index][1] + CHAR_HEIGHT + 5;
			chesty = Boss.loc[index][1] + CHAR_HEIGHT/2;
			midx1 = Boss.loc[index][0] + Boss.xvel[index];

			if(world[level][feety / TEXT_Y][midx1 / TEXT_X] < NUM_WALK_TEXT
				|| world[level][chesty / TEXT_Y][midx1 / TEXT_X] >= NUM_WALK_TEXT)
			{
				Boss.xvel[index] = 0;
			}
		}
		Boss.loc[index][0] += Boss.xvel[index];

		if(Boss.xvel[index] > 5)
			Boss.xvel[index]--;
		else if(Boss.xvel[index] < -5)
			Boss.xvel[index]++;
		else if(Boss.xvel[index] > 0 && Boss.dir[index] == 0)
			Boss.xvel[index]--;
		else if(Boss.xvel[index] < 0 && Boss.dir[index] == 1)
			Boss.xvel[index]++;

		

	}
} // End Boss AI

//Infernicus AI
for(index = 0; index < 100; index++)
{
	if(Icus.states[index] >= 0)
	{
		boss = true;
		// Point self at Slaughter

		if(Slaughter.bob.x + world_x > Icus.loc[index][0])
			Icus.dir[index] = 1;
		else
			Icus.dir[index] = 0;

		//If count is up, find something new to do
		//If state is 0, wait
		//If state is 1, puff
		//If state is 2, shoot fireball
		Icus.count[index]--;
		//If they're onscreen, move toward Slaughter
		if(Icus.loc[index][0] + ICUS_WIDTH-45 > world_x && Icus.loc[index][0]+45 < world_x + SCREEN_WIDTH &&
			Icus.loc[index][1] + ICUS_HEIGHT > world_y && Icus.loc[index][1] < world_y + SCREEN_HEIGHT)
		{
			if(Icus.states[index] == 0)
			{
				if(Icus.count[index] <= 0)
				{
					//If close enough to attack, then attack
					if(Icus.loc[index][0] + ICUS_WIDTH - 45 + 9 > Slaughter.bob.x + world_x
						&& Icus.loc[index][0] - CHAR_WIDTH + 45 - 9 < Slaughter.bob.x + world_x)
					{
						Icus.xvel[index] = 0;
						Icus.states[index] = 1;
						Icus.count[index] = 4;
						Icus.curr_frame[index] = 6;
					}
					else //Walk closer
					{
						Icus.states[index] = 0;
						Icus.count[index] = 4;
						Icus.curr_frame[index] = (Icus.curr_frame[index] + 1) % 6;
						if(Slaughter.bob.x + world_x > Icus.loc[index][0] + 45)
						{
							if(Icus.xvel[index] < 4)
								Icus.xvel[index]++;
						}
						else
						{
							if(Icus.xvel[index] > -4)
								Icus.xvel[index]--;
						}
					}
				}
			} else
			{
				//If it's time for a new frame
				if(Icus.count[index] <= 0)
				{
					Icus.curr_frame[index]++;
					if(Icus.curr_frame[index] >= 10)
					{
						Icus.curr_frame[index] = 0;
						Icus.count[index] = 20;
						Icus.states[index] = 0;
					} else if(Icus.curr_frame[index] == 9)
					{
						//Check for hit
						//Find new fire ball
						DSound_Play(infAttSound);
						for(index2 = 0; index2 < 100; index2++)
						{
							if(Flames.state[index2] == -1)
							{
								
								//Initialize invisible fireball
								if(Icus.dir[index] == 0)
								{
									Flames.loc[index2][0] = Icus.loc[index][0] - FIRE_WIDTH+45;
									Flames.xvel[index2] = -3;
								}
								else
								{
									Flames.loc[index2][0] = Icus.loc[index][0] + ICUS_WIDTH-45;
									Flames.xvel[index2] = 3;
								}

								Flames.loc[index2][1] = Icus.loc[index][1] + CHAR_WIDTH/2 + 10;
								Flames.state[index2] = Icus.dir[index];
								Flames.yvel[index2] = 0;
								Flames.count[index2] = 50;

								index2 = 100;
							}
						}
						Icus.count[index] = 3;
					} else
						Icus.count[index] = 3;		
				}
			} 
		}

		//Move as needed
		if(Icus.states[index] == 3)
		{
			Icus.xvel[index] = 0;		
			if(Icus.count[index] == 1)
				Icus.states[index] = 0;
		}
		else if(Icus.xvel[index] > 0)
		{
			feety = Icus.loc[index][1] + ICUS_HEIGHT + 5;
			chesty = Icus.loc[index][1] + ICUS_HEIGHT/2;
			midx1 = Icus.loc[index][0] + ICUS_WIDTH - 45 + Icus.xvel[index];

			if(world[level][feety / TEXT_Y][midx1 / TEXT_X] < NUM_WALK_TEXT
				|| world[level][chesty / TEXT_Y][midx1 / TEXT_X] >= NUM_WALK_TEXT)
			{
				Icus.xvel[index] = 0;
			}
		}
		else if(Icus.xvel[index] < 0)
		{
			feety = Icus.loc[index][1] + ICUS_HEIGHT + 5;
			chesty = Icus.loc[index][1] + ICUS_HEIGHT/2;
			midx1 = Icus.loc[index][0] + 45 + Icus.xvel[index];

			if(world[level][feety / TEXT_Y][midx1 / TEXT_X] < NUM_WALK_TEXT
				|| world[level][chesty / TEXT_Y][midx1 / TEXT_X] >= NUM_WALK_TEXT)
			{
				Icus.xvel[index] = 0;
			}
		}
		Icus.loc[index][0] += Icus.xvel[index];

		if(Icus.xvel[index] > 5)
			Icus.xvel[index]--;
		else if(Icus.xvel[index] < -5)
			Icus.xvel[index]++;
		else if(Icus.xvel[index] > 0 && Icus.dir[index] == 0)
			Icus.xvel[index]--;
		else if(Icus.xvel[index] < 0 && Icus.dir[index] == 1)
			Icus.xvel[index]++;

	} else if(Icus.states[index] == -2)
	{
		Icus.count[index]--;
		if(Icus.count[index] <= 0)
		{
			Icus.states[index] = -1;
		} else
		{
			for(index2 = 0; index2 < 100; index2++)
			{
				if(Gibs.state[index2][0] == -1)
				{
					for(index3 = 0; index3 < 90; index3++)
					{
						//Infernicus explode
						Gibs.state[index2][index3] = rand() % 3 + 3;
						Gibs.count[index2] = 40;
						if(Slaughter.dir == 0)
							Gibs.xvel[index2][index3] = rand() % 8 - 2;
						else
							Gibs.xvel[index2][index3] = rand() % 8 - 5;
						Gibs.yvel[index2][index3] = rand() % 20 - 18;
						Gibs.loc[index2][index3][0] = Icus.loc[index][0] + 45 + rand() % (ICUS_WIDTH - 102);
						Gibs.loc[index2][index3][1] = Icus.loc[index][1] + rand() % ICUS_HEIGHT;
					}
					index2 = 100;
				}
			}
		}
	}
} // End Infernicus AI

if (boss)
	changeCount = 101;

//If Slaughter is too close to the edge of the screen, scroll the screen.
int too_far;
int orgh;

if(Slaughter.bob.x < SCREEN_WIDTH/3)
{
	too_far = Slaughter.bob.x - SCREEN_WIDTH/3;
	orgh = world_x;
	if ((world_x+=too_far) < 0)
       world_x = 0;

	Slaughter.bob.x -= world_x - orgh;

}
if (Slaughter.bob.x > 2*SCREEN_WIDTH/3)
{
	too_far = Slaughter.bob.x - 2 * SCREEN_WIDTH / 3;
	orgh = world_x;
	max_h = (world_width - HORZ_TILE_NUM) * TEXT_X;
    if ((world_x+=too_far) >= max_h)
       world_x = max_h - 1;

	Slaughter.bob.x -= world_x - orgh;
	
}
if (Slaughter.bob.y+25 < SCREEN_HEIGHT/3)
{
	too_far = Slaughter.bob.y+25 - SCREEN_HEIGHT/3;
	orgh = world_y;
	if ((world_y+=too_far) < 0)
       world_y = 0;

	Slaughter.bob.y -= world_y - orgh;

}
if (Slaughter.bob.y+25 > 2*SCREEN_HEIGHT/3)
{
	too_far = Slaughter.bob.y+25 - 2 * SCREEN_HEIGHT / 3;
	orgh = world_y;
	max_h = (world_height - VERT_TILE_NUM) * TEXT_Y;
    if ((world_y+=too_far) >= max_h)
       world_y = max_h - 1;

	Slaughter.bob.y -= world_y - orgh;
}

// draw the current window
for (index_y = start_map_y; index_y <= end_map_y; index_y++)
    {
    for (index_x = start_map_x; index_x <= end_map_x; index_x++)
        {
        // set position to blit
        textures.x = texture_x;
        textures.y = texture_y;
        
        // set frame
        textures.curr_frame = world[level][index_y][index_x];

        // draw the texture
        Draw_BOB(&textures,lpddsback);

        // update texture position
        texture_x+=TEXT_X;

        } // end for map_x

    // reset x postion, update y
    texture_x =  offset_x;
    texture_y += TEXT_Y;

    } // end for map_y

//Slaughter.bob.curr_frame = 0;

//Draw Gibs
for(index = 0; index < 100; index++)
{
	if(Gibs.state[index][0] != -1)
	{
		for(index2 = 0; index2 < 90; index2++)
		{
			//Maybe check if on screen
			Gibs.bob.curr_frame = Gibs.state[index][index2];
			Gibs.bob.x = Gibs.loc[index][index2][0] - world_x;
			Gibs.bob.y = Gibs.loc[index][index2][1] - world_y;
			Draw_BOB(&Gibs.bob, lpddsback);

			// Move Gibs
			Gibs.loc[index][index2][0] += Gibs.xvel[index][index2];
			if(world[level][ Gibs.loc[index][index2][1]/TEXT_Y ][ Gibs.loc[index][index2][0]/TEXT_X ] > NUM_WALK_TEXT)
			{
				Gibs.yvel[index][index2] = 0;
				Gibs.xvel[index][index2] = 0;
			}
			Gibs.loc[index][index2][1] += Gibs.yvel[index][index2];
			Gibs.yvel[index][index2]++;
		}
		Gibs.count[index]--;
		if(Gibs.count[index] <= 0)
			Gibs.state[index][0] = -1;
	}

	//Fire
	
	if(Flames.state[index] != -1)
	{
		//Check for wall hit
		if(Flames.count[index] <= 0
			|| world[level][ Flames.loc[index][1]/TEXT_Y ][ Flames.loc[index][0]/TEXT_X ] > NUM_WALK_TEXT
			|| world[level][ (Flames.loc[index][1] + FIRE_HEIGHT)/TEXT_Y ][ (Flames.loc[index][0] + FIRE_WIDTH)/TEXT_X ] > NUM_WALK_TEXT
			|| world[level][ Flames.loc[index][1]/TEXT_Y ][ (Flames.loc[index][0] + FIRE_WIDTH)/TEXT_X ] > NUM_WALK_TEXT
			|| world[level][ (Flames.loc[index][1] + FIRE_HEIGHT)/TEXT_Y ][ Flames.loc[index][0]/TEXT_X ] > NUM_WALK_TEXT)
		{
			Flames.state[index] = -1;
		} else
		{
			//Move Fire
			Flames.loc[index][0] += Flames.xvel[index];
			Flames.loc[index][1] += Flames.yvel[index];

			//Draw Fire
			if(Flames.state[index] == 0)
				Flames.bob.curr_frame = 0;
			else 
				Flames.bob.curr_frame = 1;

			Flames.bob.x = Flames.loc[index][0] - world_x;
			Flames.bob.y = Flames.loc[index][1] - world_y;
			if(Flames.state[index] < 5)
				Draw_BOB(&Flames.bob, lpddsback);

			Flames.count[index]--;
		}
	}
}

//Move Beam
if(beam.state >= 0)
{
	//Check for enemy hit
	for(index = 0; index < 100; index++)
	{
		//Beam Infernican Hit
		if(Infs.states[index] >= 0)
		{
			if(beam.y > Infs.loc[index][1] &&
				beam.y < Infs.loc[index][1] + CHAR_HEIGHT &&
				beam.x + BEAM_WIDTH > Infs.loc[index][0] &&
				beam.x < Infs.loc[index][0] + CHAR_WIDTH)
			{
				//Stun enemy
				Infs.states[index] = 3;
				Infs.count[index] = 50;
				Infs.xvel[index] = 0;
				if(beam.count > 5)
					beam.count = 5;
			}
		}

		//Beam miniInfernican Hit
		if(Mini.states[index] >= 0)
		{
			if(beam.y > Mini.loc[index][1] &&
				beam.y < Mini.loc[index][1] + MINI_HEIGHT &&
				beam.x + BEAM_WIDTH > Mini.loc[index][0] &&
				beam.x < Mini.loc[index][0] + MINI_WIDTH)
			{
				//Stun enemy
				Mini.states[index] = 3;
				Mini.count[index] = 60;
				if(beam.count > 5)
					beam.count = 5;
			}
		}

		//Beam Peasant Hit
		if(Peas.states[index] >= 0)
		{
			if(beam.y > Peas.loc[index][1] + 20 &&
				beam.y < Peas.loc[index][1] + CHAR_HEIGHT &&
				beam.x + BEAM_WIDTH > Peas.loc[index][0] &&
				beam.x < Peas.loc[index][0] + CHAR_WIDTH)
			{
				//Stun enemy
				Peas.states[index] = 3;
				Peas.count[index] = 60;
				if(beam.count > 5)
					beam.count = 5;
			}
		}

		//Beam Boss Hit
		if(Boss.states[index] >= 0)
		{
			if(beam.y > Boss.loc[index][1] + 20 &&
				beam.y < Boss.loc[index][1] + CHAR_HEIGHT &&
				beam.x + BEAM_WIDTH > Boss.loc[index][0] &&
				beam.x < Boss.loc[index][0] + CHAR_WIDTH)
			{
				//Stun enemy
				Boss.states[index] = 3;
				Boss.count[index] = 40;
				if(beam.count > 5)
					beam.count = 5;
			}
		}

		//Beam Infernicus Hit
		if(Icus.states[index] >= 0)
		{
			if(beam.y > Icus.loc[index][1] + 20 &&
				beam.y < Icus.loc[index][1] + ICUS_HEIGHT &&
				beam.x + BEAM_WIDTH > Icus.loc[index][0] + 45 &&
				beam.x < Icus.loc[index][0] + ICUS_WIDTH - 45)
			{
				//Stun enemy
				Icus.states[index] = 3;
				Icus.count[index] = 35;
				if(beam.count > 5)
					beam.count = 5;
			}
		}
	}
	//Check for wall hit
	if(beam.count <= 0
		|| world[level][ beam.y/TEXT_Y ][ beam.x/TEXT_X ] > NUM_WALK_TEXT
		|| world[level][ beam.y/TEXT_Y ][ (beam.x + BEAM_WIDTH)/TEXT_X ] > NUM_WALK_TEXT)
	{
		beam.state = -1;
	} else
	{
		//Draw Beam
		beam.x += beam.xvel;
		beam.y += beam.yvel;

		if(!FAILED(lpddsback->Lock(NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT, NULL)))
		{
			Draw_Line(beam.x - world_x, beam.y - world_y - 1, beam.x + BEAM_WIDTH - world_x, beam.y - world_y - 1, 151, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Draw_Line(beam.x - world_x, beam.y - world_y, beam.x + BEAM_WIDTH - world_x, beam.y - world_y, 153, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
			Draw_Line(beam.x - world_x, beam.y - world_y + 1, beam.x + BEAM_WIDTH - world_x, beam.y - world_y + 1, 151, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);

			lpddsback->Unlock(NULL);
		}

		beam.count--;
	}
}

//Draw Slaughter
if(Slaughter.inv % 2 == 0 && Slaughter.state >= 0)
{
	if(Slaughter.dir == 1)
	{
		Slaughter.bob.curr_frame += NUM_SLAUGHTERS;
		Draw_BOB(&Slaughter.bob, lpddsback);
		Slaughter.bob.curr_frame -= NUM_SLAUGHTERS;
	} else
		Draw_BOB(&Slaughter.bob, lpddsback);
}

//Draw Infernicans
for(index = 0; index < 100; index++)
{
	if(Infs.states[index] >= 0)
	{
		if(Infs.loc[index][0] + CHAR_WIDTH > world_x && Infs.loc[index][0] < world_x + SCREEN_WIDTH &&
			Infs.loc[index][1] + CHAR_HEIGHT > world_y && Infs.loc[index][1] < world_y + SCREEN_HEIGHT)
		{
			if(Infs.dir[index] == 0)
				Infs.bob.curr_frame = Infs.curr_frame[index] + NUM_INFERNICANS;
			else
				Infs.bob.curr_frame = Infs.curr_frame[index];
			Infs.bob.x = Infs.loc[index][0] - world_x;
			Infs.bob.y = Infs.loc[index][1] - world_y;
			Draw_BOB(&Infs.bob, lpddsback);
		}
	}

	//Draw MiniInfernicans
	if(Mini.states[index] >= 0 && Mini.xvel[index] % 2 == 0)
	{
		if(Mini.loc[index][0] + MINI_WIDTH > world_x && Mini.loc[index][0] < world_x + SCREEN_WIDTH &&
			Mini.loc[index][1] + MINI_HEIGHT > world_y && Mini.loc[index][1] < world_y + SCREEN_HEIGHT)
		{
			if(Mini.dir[index] == 0)
				Mini.bob.curr_frame = Mini.curr_frame[index] + NUM_MINI;
			else
				Mini.bob.curr_frame = Mini.curr_frame[index];

			Mini.bob.curr_frame += (Mini.type[index] - 1) * 3;
			Mini.bob.x = Mini.loc[index][0] - world_x;
			Mini.bob.y = Mini.loc[index][1] - world_y;
			Draw_BOB(&Mini.bob, lpddsback);
		}
	}

	//Draw Peasants
	if(Peas.states[index] >= 0)
	{
		if(Peas.loc[index][0] + CHAR_WIDTH > world_x && Peas.loc[index][0] < world_x + SCREEN_WIDTH &&
			Peas.loc[index][1] + CHAR_HEIGHT > world_y && Peas.loc[index][1] < world_y + SCREEN_HEIGHT)
		{
			if(Peas.dir[index] == 0)
				Peas.bob.curr_frame = Peas.curr_frame[index] + NUM_PEAS;
			else
				Peas.bob.curr_frame = Peas.curr_frame[index];

			Peas.bob.x = Peas.loc[index][0] - world_x;
			Peas.bob.y = Peas.loc[index][1] - world_y;
			Draw_BOB(&Peas.bob, lpddsback);
		}
	}

	//Draw Bosses
	if(Boss.states[index] >= 0)
	{
		if(Boss.loc[index][0] + CHAR_WIDTH > world_x && Boss.loc[index][0] < world_x + SCREEN_WIDTH &&
			Boss.loc[index][1] + CHAR_HEIGHT > world_y && Boss.loc[index][1] < world_y + SCREEN_HEIGHT)
		{
			if(Boss.dir[index] == 0)
				Boss.bob.curr_frame = Boss.curr_frame[index] + NUM_BOSS;
			else
				Boss.bob.curr_frame = Boss.curr_frame[index];

			if(Boss.type[index] == 2)
				Boss.bob.curr_frame += 12;

			Boss.bob.x = Boss.loc[index][0] - world_x;
			Boss.bob.y = Boss.loc[index][1] - world_y;
			if(!((Boss.dir[index] == 1 && Boss.xvel[index] < 0 && -Boss.xvel[index] % 2 == 1)
				|| (Boss.dir[index] == 0 && Boss.xvel[index] > 0 && Boss.xvel[index] % 2 == 1)))
				Draw_BOB(&Boss.bob, lpddsback);
		}
	}

	//Draw Infernicus
	if(Icus.states[index] >= 0)
	{
		if(Icus.loc[index][0] + ICUS_WIDTH - 45 > world_x && Icus.loc[index][0] + 45 < world_x + SCREEN_WIDTH &&
			Icus.loc[index][1] + ICUS_HEIGHT > world_y && Icus.loc[index][1] < world_y + SCREEN_HEIGHT)
		{
			if(Icus.dir[index] == 0)
				Icus.bob.curr_frame = Icus.curr_frame[index] + NUM_ICUS;
			else
				Icus.bob.curr_frame = Icus.curr_frame[index];

			Icus.bob.x = Icus.loc[index][0] - world_x;
			Icus.bob.y = Icus.loc[index][1] - world_y;
			if(!((Icus.dir[index] == 1 && Icus.xvel[index] < 0 && -Icus.xvel[index] % 2 == 1)
				|| (Icus.dir[index] == 0 && Icus.xvel[index] > 0 && Icus.xvel[index] % 2 == 1)))
				Draw_BOB(&Icus.bob, lpddsback);
		}
	}
}

// draw some info
//Draw_Text_GDI("USE ARROW KEYS TO MOVE, <ESC> to Exit.",8,8,RGB(255,255,255),lpddsback);

sprintf(buffer, "Health:");
Draw_Text_GDI(buffer,8, 8, RGB(255, 255, 255),lpddsback);

sprintf(buffer, "Mana:");
Draw_Text_GDI(buffer,14, 32, RGB(255, 255, 255),lpddsback);

int hcolor;
if(Slaughter.health > 70)
	hcolor = 111;
else if (Slaughter.health > 40)
	hcolor = 200;
else
	hcolor = 153;

if(!FAILED(lpddsback->Lock(NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT, NULL)))
{

	Draw_Line(64, 8, 165, 8, 253, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
	Draw_Line(64, 24, 165, 24, 253, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
	Draw_Line(64, 8, 64, 24, 253, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
	Draw_Line(165, 8, 165, 24, 253, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);

	for(index = 0; index < Slaughter.health; index++)
	{
		Draw_Line(65 + index, 9, 65 + index, 23, hcolor, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
	}

	lpddsback->Unlock(NULL);

}

if(!FAILED(lpddsback->Lock(NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT, NULL)))
{

	Draw_Line(64, 32, 165, 32, 253, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
	Draw_Line(64, 48, 165, 48, 253, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
	Draw_Line(64, 32, 64, 48, 253, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
	Draw_Line(165, 32, 165, 48, 253, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);

	for(index = 0; index < Slaughter.mana/10; index++)
	{
		Draw_Line(65 + index, 33, 65 + index, 47, 63, (UCHAR *)ddsd.lpSurface, (int)ddsd.lPitch);
	}

	lpddsback->Unlock(NULL);

}
if(Slaughter.state == -1)
{
	sprintf(buffer, "You Lose!");
	Draw_Text_GDI(buffer, 360, 280, RGB(255,0,0), lpddsback);
} else
{
	//Check for win
	if(level == 0)
	{
		for(index = 0; index < 10; index++)
		{
			if (levelList[level].endx[index] == -1)
				index = 10;
			else if((levelList[level].endx[index] + 1) * TILE_WIDTH > (int)Slaughter.bob.x + world_x
				&& levelList[level].endx[index] * TILE_WIDTH < (int)Slaughter.bob.x + world_x + CHAR_WIDTH
				&& (levelList[level].endy[index] + 1) * TILE_WIDTH > (int)Slaughter.bob.y + world_y
				&& levelList[level].endy[index] * TILE_WIDTH < (int)Slaughter.bob.y + world_y + CHAR_HEIGHT)
			{
				screenChange = true;
				level++;
				Out.open("save");
				Out << level;
				Out.close();
				index = 10;
				reset();
				screenLoc = 2;
			}
		}
	} else if(boss == false)
	{
		if(changeCount <= 0)
		{
			screenChange = true;
			level++;
			Out.open("save");
			Out << level;
			Out.close();
			index = 10;
			reset();
			screenLoc = 2;
		} else
			changeCount--;
	}
}

feety = Mini.loc[0][1] + MINI_HEIGHT + 5;
chesty = Mini.loc[0][1] + MINI_HEIGHT/2;
midx1 = Mini.loc[0][0] + MINI_WIDTH + Mini.xvel[0];
/*
if(world[level][feety / TEXT_Y][midx1 / TEXT_X] < NUM_WALK_TEXT
	|| world[level][chesty / TEXT_Y][midx1 / TEXT_X] >= NUM_WALK_TEXT)
{
	Mini.xvel[index] = 0;
}
*/
//sprintf(buffer,"World Position = [%d, %d, %i, %i, %i, %i, %i]     ", Slaughter.state, Mini.loc[0][1], world[level][chesty / TEXT_Y][midx1 / TEXT_X], Slaughter.bob.y + world_y, Infs.xvel[0], (Infs.loc[0][1] + CHAR_HEIGHT)/TEXT_Y, ((Infs.loc[0][0] + (CHAR_WIDTH) / 6) + Infs.xvel[0] - 1) / TEXT_X);
//Draw_Text_GDI(buffer,8,screen_height - 32 - 24,RGB(0,255,0),lpddsback);

//Draw_Line(32, 8, 64, 8, RGB(255, 0, 0), (UCHAR *)lpddsback, 800);
// flip the surfaces
DDraw_Flip();

// sync to 30 fps
Wait_Clock(30);

// return success
return(1);

} // end Game_Main

//////////////////////////////////////////////////////////

void Slaughter_Hit(int damage, int dir)
{
	int index, index2, index3;

	Slaughter.health -= damage;

	if(Slaughter.health <= 0) //Slaughter died
	{
		if(Slaughter.state != -1)
		{
			DSound_Play(deadSound);
			Slaughter.count = 20;
			Slaughter.state = -1;
		}
		for(index2 = 0; index2 < 100; index2++)
		{
			if(Gibs.state[index2][0] == -1)
			{
				for(index3 = 0; index3 < 90; index3++)
				{
					//Slaughter explode
					Gibs.state[index2][index3] = rand() % 3;
					Gibs.count[index2] = 50;
					Gibs.xvel[index2][index3] = rand() % 17 - 8;
					Gibs.yvel[index2][index3] = rand() % 19 - 10;
					Gibs.loc[index2][index3][0] = Slaughter.bob.x + world_x + rand() % CHAR_WIDTH;
					Gibs.loc[index2][index3][1] = Slaughter.bob.y + world_y + rand() % CHAR_HEIGHT;
				}
				index2 = 100;
			}
		}
	} else
	{
		DSound_Play(hitSound);
		if (dir == 0)
			Slaughter.xvel = -20;
		else
			Slaughter.xvel = 20;
		Slaughter.inv = 50;
	}
}

void reset()
{
	int index, index2, index3, infIndex = 0, bossIndex = 0;
	int minIndex=0, icusIndex=0, peaIndex=0;

	for(index = 0; index < 4; index++)
	{
		for(index2 = 0; index2 < 23; index2++)
		{
			for(index3 = 0; index3 < 63; index3++)
				world[index][index2][index3] = origWorld[index][index2][index3];
		}
	}

	//Initialize Slaughter
	world_x = (levelList[level].startx - HORZ_TILE_NUM/2) * TILE_WIDTH;
	if(world_x < 0)
		world_x = 0;
	else if (world_x >= levelList[level].width * TILE_WIDTH - SCREEN_WIDTH / TILE_WIDTH)
		world_x = levelList[level].width * TILE_WIDTH - SCREEN_WIDTH / TILE_WIDTH - 1;

	world_y = (levelList[level].starty - VERT_TILE_NUM/2) * TILE_WIDTH;
	if(world_y < 0)
		world_y = 0;
	else if (world_y >= levelList[level].height * TILE_WIDTH - SCREEN_HEIGHT)
		world_y = levelList[level].height * TILE_WIDTH - SCREEN_HEIGHT - 1;

	world_height = levelList[level].height;
	world_width = levelList[level].width;

	Slaughter.bob.x = levelList[level].startx * TILE_WIDTH - world_x;
	Slaughter.bob.y = levelList[level].starty * TILE_WIDTH - world_y - 40;
	Slaughter.dir = 1;
	Slaughter.xvel = 0;
	Slaughter.yvel = 0;
	Slaughter.state = 0;
	Slaughter.bob.curr_frame = 0;
	Slaughter.count = 3;
	Slaughter.health = 100;
	Slaughter.mana = 1000;
	Slaughter.inv = 0;

	//Initialize Stuff
	for(index = 0; index < 100; index++)
	{
		Gibs.state[index][0] = -1;
		Infs.states[index] = -1;
		Mini.states[index] = -1;
		Peas.states[index] = -1;
		Boss.states[index] = -1;
		Icus.states[index] = -1;
	}

	for(index = 0; index < world_height; index++)
	{
		for(index2 = 0; index2 < world_width; index2++)
		{
			if(world[level][index][index2] == -1)
			{
				world[level][index][index2] = levelList[level].bgNum;
				Infs.loc[infIndex][0] = index2*TEXT_X;
				Infs.loc[infIndex][1] = index*TEXT_Y-(CHAR_HEIGHT-TEXT_Y+1);
				Infs.states[infIndex] = 0;
				Infs.count[infIndex] = 3;
				Infs.dir[infIndex] = 0;
				Infs.maxx[infIndex] = Infs.loc[infIndex][0] + 180;
				Infs.minx[infIndex] = Infs.loc[infIndex][0] - 200;
				Infs.xvel[infIndex] = 0;
				Infs.yvel[infIndex] = 0;
				Infs.curr_frame[infIndex++] = 0;
			}

			//Initialize miniInfernicans
			else if(world[level][index][index2] == -2)
			{
				world[level][index][index2] = levelList[level].bgNum;
				Mini.loc[minIndex][0] = index2*TEXT_X;
				Mini.loc[minIndex][1] = index*TEXT_Y-(MINI_HEIGHT-TEXT_Y+1);
				Mini.states[minIndex] = 0;
				Mini.type[minIndex] = 1;
				Mini.count[minIndex] = 3;
				Mini.dir[minIndex] = 0;
				Mini.health[minIndex] = 30;
				Mini.xvel[minIndex] = 0;
				Mini.curr_frame[minIndex++] = 0;
			} else if(world[level][index][index2] == -3)
			{
				world[level][index][index2] = levelList[level].bgNum;
				Mini.loc[minIndex][0] = index2*TEXT_X;
				Mini.loc[minIndex][1] = index*TEXT_Y-(MINI_HEIGHT-TEXT_Y+1);
				Mini.states[minIndex] = 0;
				Mini.type[minIndex] = 2;
				Mini.count[minIndex] = 3;
				Mini.dir[minIndex] = 0;
				Mini.health[minIndex] = 60;
				Mini.xvel[minIndex] = 0;
				Mini.curr_frame[minIndex++] = 0;
			} else if(world[level][index][index2] == -4)
			{
				world[level][index][index2] = levelList[level].bgNum;
				Mini.loc[minIndex][0] = index2*TEXT_X;
				Mini.loc[minIndex][1] = index*TEXT_Y-(MINI_HEIGHT-TEXT_Y+1);
				Mini.states[minIndex] = 0;
				Mini.type[minIndex] = 3;
				Mini.count[minIndex] = 3;
				Mini.dir[minIndex] = 0;
				Mini.health[minIndex] = 90;
				Mini.xvel[minIndex] = 0;
				Mini.curr_frame[minIndex++] = 0;
			}

			//Initialize Peasants
			else if(world[level][index][index2] == -5)
			{
				world[level][index][index2] = levelList[level].bgNum;
				Peas.loc[peaIndex][0] = index2*TEXT_X;
				Peas.loc[peaIndex][1] = index*TEXT_Y-(CHAR_HEIGHT-TEXT_Y+1);
				Peas.states[peaIndex] = 0;
				Peas.count[peaIndex] = 3;
				Peas.dir[peaIndex] = 0;
				Peas.health[peaIndex] = 20;
				Peas.xvel[peaIndex] = 0;
				Peas.curr_frame[peaIndex++] = 0;
			}

			//Initialize Bosses
			else if(world[level][index][index2] == -6)
			{
				world[level][index][index2] = levelList[level].bgNum;
				Boss.type[bossIndex] = 1;
				Boss.loc[bossIndex][0] = index2*TEXT_X;
				Boss.loc[bossIndex][1] = index*TEXT_Y-(CHAR_HEIGHT-TEXT_Y+1);
				Boss.states[bossIndex] = 0;
				Boss.count[bossIndex] = 3;
				Boss.dir[bossIndex] = 0;
				Boss.health[bossIndex] = 200;
				Boss.xvel[bossIndex] = 0;
				Boss.curr_frame[bossIndex++] = 0;
			} else if(world[level][index][index2] == -7)
			{
				world[level][index][index2] = levelList[level].bgNum;
				Boss.type[bossIndex] = 2;
				Boss.loc[bossIndex][0] = index2*TEXT_X;
				Boss.loc[bossIndex][1] = index*TEXT_Y-(CHAR_HEIGHT-TEXT_Y+1);
				Boss.states[bossIndex] = 0;
				Boss.count[bossIndex] = 3;
				Boss.dir[bossIndex] = 0;
				Boss.health[bossIndex] = 150;
				Boss.xvel[bossIndex] = 0;
				Boss.curr_frame[bossIndex++] = 0;
			}

			//Initialize Infernicus
			else if(world[level][index][index2] == -8)
			{
				world[level][index][index2] = levelList[level].bgNum;
				Icus.loc[icusIndex][0] = index2*TEXT_X;
				Icus.loc[icusIndex][1] = index*TEXT_Y-(CHAR_HEIGHT-TEXT_Y+1);
				Icus.states[icusIndex] = 0;
				Icus.count[icusIndex] = 3;
				Icus.dir[icusIndex] = 0;
				Icus.health[icusIndex] = 300;
				Icus.xvel[icusIndex] = 0;
				Icus.curr_frame[icusIndex++] = 0;
			}
		}
		// Initialize Fire
		Flames.state[index] = -1;
	}
}

//////////////////////////////////////////////////////////

void print_story(char* text, int lines, int color)
{
	char* curr;
	char* prev;
	int x = 60;
	int y = 8;
	int currLine = 0;

	curr = prev = text;

	while(*curr != '\0' && currLine < lines)
	{
		if(*curr == '\n')
		{
			currLine++;
			*curr = '\0';
			if(currLine < lines)
			{
				Draw_Text_GDI(prev,x, y, RGB(255, 255, 255), lpddsback);
				y += 24;
				curr++;
				prev = curr;
			}
		} else
			curr++;
	}
	Draw_Text_GDI(prev,x, y, RGB(color, color, color), lpddsback);
	
}